// Planificacion_TrayDlg.cpp: archivo de implementacin
//

#include "stdafx.h"
#include "Planificacion_Tray.h"
#include "Planificacion_TrayDlg.h"
#include "libdetecta.h"

#define WM_SOCKET_CREATE WM_USER + 1
#define WM_SOCKET_KOALA WM_USER + 2

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
#pragma warning(disable:4996)

#define PUERTO 3490    /* Puerto del socket servidor CREATE*/
#define PUERTO2 3492    /* Puerto del socket servidor KOALA*/
// Cuadro de dilogo CAboutDlg utilizado para el comando Acerca de

double g_dbTheta[3][3];
int g_nRecibidos; //para saber que recibo las dos rececepciones de ambos robots

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Datos del cuadro de dilogo
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Compatibilidad con DDX/DDV

// Implementacin
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cuadro de dilogo de CPlanificacion_TrayDlg

CPlanificacion_TrayDlg::CPlanificacion_TrayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlanificacion_TrayDlg::IDD, pParent)
	, m_nE(10)
	, m_flKRHO((float)0.8)
	, m_flKALFA((float)2.0)
	, m_flKBETA((float)-0.6)
	, m_flKP((float)0.2)
	, m_flPeriodo((float)0.05)
	, m_flKPX((float)0.1)
	, m_flKPY((float)0.8)
	, m_flKVX((float)0.0)
	, m_flKVY((float)0.0)
	, m_nL1(1630)
	, m_nL2(1330)
	, m_nRadio(50)
	, m_flFrecuencia((float)0.02)
	, m_nVelocidad(100)
	, m_sResumen(_T(""))
	, m_nPosX(0)
	, m_nPosY(0)
	, m_nGrados(0)
	, m_nFinalX(0)
	, m_nFinalY(0)
	, m_nRaster(20)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPlanificacion_TrayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_E, m_EditE);
	DDX_Text(pDX, IDC_EDIT_E, m_nE);
	DDV_MinMaxInt(pDX, m_nE, 1, 500);
	DDX_Control(pDX, IDC_EDIT_PERIODO, m_EditPeriodo);
	DDX_Text(pDX, IDC_EDIT_PERIODO, m_flPeriodo);
	DDV_MinMaxFloat(pDX, m_flPeriodo, 0, 1);
	DDX_Control(pDX, IDC_EDIT_KPX, m_EditKPX);
	DDX_Text(pDX, IDC_EDIT_KPX, m_flKPX);
	DDV_MinMaxFloat(pDX, m_flKPX, 0, 2);
	DDX_Control(pDX, IDC_EDIT_KPY, m_EditKPY);
	DDX_Text(pDX, IDC_EDIT_KPY, m_flKPY);
	DDV_MinMaxFloat(pDX, m_flKPY, 0, 2);
	DDX_Control(pDX, IDC_EDIT_KVX, m_EditKVX);
	DDX_Text(pDX, IDC_EDIT_KVX, m_flKVX);
	DDV_MinMaxFloat(pDX, m_flKVX, 0, 2);
	DDV_MinMaxFloat(pDX, m_flKVY, 0, 2);
	DDX_Control(pDX, IDC_EDIT_KVY, m_EditKVY);
	DDX_Text(pDX, IDC_EDIT_KVY, m_flKVY);
	DDX_Control(pDX, IDC_EDIT_L1, m_EditL1);
	DDX_Text(pDX, IDC_EDIT_L1, m_nL1);
	DDV_MinMaxInt(pDX, m_nL1, 50, 3000);
	DDX_Control(pDX, IDC_EDIT_L2, m_EditL2);
	DDX_Text(pDX, IDC_EDIT_L2, m_nL2);
	DDV_MinMaxInt(pDX, m_nL2, 50, 3000);
	DDX_Control(pDX, IDC_EDIT_RADIO, m_EditRadio);
	DDX_Text(pDX, IDC_EDIT_RADIO, m_nRadio);
	DDV_MinMaxInt(pDX, m_nRadio, 50, 3000);
	DDX_Control(pDX, IDC_EDIT_FRECUENCIA, m_EditFrecuencia);
	DDX_Text(pDX, IDC_EDIT_FRECUENCIA, m_flFrecuencia);
	DDV_MinMaxDouble(pDX, m_flFrecuencia, 0.009, 5);
	DDX_Control(pDX, IDC_EDIT_VELOCIDAD, m_EditVelocidad);
	DDX_Text(pDX, IDC_EDIT_VELOCIDAD, m_nVelocidad);
	DDV_MinMaxInt(pDX, m_nVelocidad, 10, 500);
	DDX_Control(pDX, IDC_RADIO_TRAYECTORIA, m_ButtonTrayectoria);
	DDX_Control(pDX, IDC_RADIO_CAMINO, m_ButtonCamino);
	DDX_Control(pDX, IDC_RADIO_RECTANGULO, m_ButtonRectangulo);
	DDX_Control(pDX, IDC_BUTTONEMPEZAR, m_ButtonComenzar);
	DDX_Control(pDX, IDC_BUTTONEMPEZARTRAY, m_ButtonEmpezarTray);
	DDX_Control(pDX, IDC_RADIO_CIRCUNFERENCIA, m_ButtonCircun);
	DDX_Control(pDX, IDC_RADIO_POSICION, m_ButtonPosicion);
	DDX_Control(pDX, IDC_RADIO_TRAY, m_ButtonTray);
	DDX_Control(pDX, IDC_RADIO_SEGUIMIENTO, m_ButtonSeguimiento);
	DDX_Text(pDX, IDC_EDITRESUMEN, m_sResumen);
	DDX_Text(pDX, IDC_EDIT_PX, m_nPosX);
	DDX_Text(pDX, IDC_EDIT_PY, m_nPosY);
	DDX_Text(pDX, IDC_EDIT_OR, m_nGrados);
	DDV_MinMaxInt(pDX, m_nGrados, -360, 360);
	DDX_Control(pDX, IDC_EDIT_POSX, m_EditPosX);
	DDX_Control(pDX, IDC_EDIT_POSY, m_EditPosY);
	DDX_Text(pDX, IDC_EDIT_POSX, m_nFinalX);
	DDX_Text(pDX, IDC_EDIT_POSY, m_nFinalY);	
	DDX_Text(pDX, IDC_EDITRASTER, m_nRaster);
	DDV_MinMaxInt(pDX, m_nRaster, 1, 500);
	DDX_Control(pDX, IDC_EDITRASTER, m_EditRaster);
	DDX_Control(pDX, IDC_CHECKTRAY, m_CheckTray);
	DDX_Check(pDX, IDC_CHECKTRAY, m_nTray);
	DDX_Text(pDX, IDC_EDIT_KRHO, m_flKRHO);
	DDX_Text(pDX, IDC_EDIT_KALFA, m_flKALFA);
	DDX_Text(pDX, IDC_EDIT_KBETA, m_flKBETA);
	DDX_Text(pDX, IDC_EDIT_KP, m_flKP);
	DDX_Control(pDX, IDC_EDIT_KRHO, m_EditKRHO);
	DDX_Control(pDX, IDC_EDIT_KALFA, m_EditKALFA);
	DDX_Control(pDX, IDC_EDIT_KBETA, m_EditKBETA);
	DDX_Control(pDX, IDC_EDIT_KP, m_EditKP);
}

BEGIN_MESSAGE_MAP(CPlanificacion_TrayDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CPlanificacion_TrayDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_RADIO_TRAYECTORIA, &CPlanificacion_TrayDlg::OnBnClickedRadioTrayectoria)
	ON_BN_CLICKED(IDC_RADIO_CAMINO, &CPlanificacion_TrayDlg::OnBnClickedRadioCamino)
	ON_BN_CLICKED(IDCANCEL, &CPlanificacion_TrayDlg::OnBnClickedCancel)
	ON_EN_KILLFOCUS(IDC_EDIT_E, &CPlanificacion_TrayDlg::OnEnKillfocusEditE)
	ON_EN_KILLFOCUS(IDC_EDIT_KPX, &CPlanificacion_TrayDlg::OnEnKillfocusEditKpx)
	ON_EN_KILLFOCUS(IDC_EDIT_KPY, &CPlanificacion_TrayDlg::OnEnKillfocusEditKpy)
	ON_EN_KILLFOCUS(IDC_EDIT_KVX, &CPlanificacion_TrayDlg::OnEnKillfocusEditKvx)
	ON_EN_KILLFOCUS(IDC_EDIT_KVY, &CPlanificacion_TrayDlg::OnEnKillfocusEditKvy)
	ON_EN_KILLFOCUS(IDC_EDIT_PERIODO, &CPlanificacion_TrayDlg::OnEnKillfocusEditPeriodo)
	ON_EN_KILLFOCUS(IDC_EDIT_L1, &CPlanificacion_TrayDlg::OnEnKillfocusEditL1)
	ON_EN_KILLFOCUS(IDC_EDIT_RADIO, &CPlanificacion_TrayDlg::OnEnKillfocusEditRadio)
	ON_EN_KILLFOCUS(IDC_EDIT_VELOCIDAD, &CPlanificacion_TrayDlg::OnEnKillfocusEditVelocidad)
	ON_EN_KILLFOCUS(IDC_EDIT_L2, &CPlanificacion_TrayDlg::OnEnKillfocusEditL2)
	ON_EN_KILLFOCUS(IDC_EDIT_FRECUENCIA, &CPlanificacion_TrayDlg::OnEnKillfocusEditFrecuencia)
	ON_EN_KILLFOCUS(IDC_EDIT_KRHO, &CPlanificacion_TrayDlg::OnEnKillfocusEditKRHO)
	ON_EN_KILLFOCUS(IDC_EDIT_KALFA, &CPlanificacion_TrayDlg::OnEnKillfocusEditKALFA)
	ON_EN_KILLFOCUS(IDC_EDIT_KBETA, &CPlanificacion_TrayDlg::OnEnKillfocusEditKBETA)
	ON_EN_KILLFOCUS(IDC_EDIT_KP, &CPlanificacion_TrayDlg::OnEnKillfocusEditKP)
	ON_BN_CLICKED(IDC_RADIO_RECTANGULO, &CPlanificacion_TrayDlg::OnBnClickedRadioRectangulo)
	ON_BN_CLICKED(IDC_RADIO_CIRCUNFERENCIA, &CPlanificacion_TrayDlg::OnBnClickedRadioCircunferencia)
	ON_BN_CLICKED(IDC_BUTTONEMPEZAR, &CPlanificacion_TrayDlg::OnBnClickedButtonempezar)
	ON_BN_CLICKED(IDC_RADIO_POSICION, &CPlanificacion_TrayDlg::OnBnClickedRadioPosicion)
	ON_BN_CLICKED(IDC_RADIO_TRAY, &CPlanificacion_TrayDlg::OnBnClickedRadioTray)
	ON_MESSAGE(WM_SOCKET_CREATE, OnRecepcion_CREATE)
	ON_MESSAGE(WM_SOCKET_KOALA, OnRecepcion_KOALA)
	ON_BN_CLICKED(IDC_BUTTONPARADA, &CPlanificacion_TrayDlg::OnBnClickedButtonparada)
	ON_BN_CLICKED(IDC_BUTTONEMPEZARTRAY, &CPlanificacion_TrayDlg::OnBnClickedButtonempezartray)
	ON_BN_CLICKED(IDC_BUTTONSIGUE, &CPlanificacion_TrayDlg::OnBnClickedButtonsigue)
	ON_BN_CLICKED(IDC_RADIO_SEGUIMIENTO, &CPlanificacion_TrayDlg::OnBnClickedRadioSeguimiento)
END_MESSAGE_MAP()


// Controladores de mensaje de CPlanificacion_TrayDlg

BOOL CPlanificacion_TrayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Agregar el elemento de men "Acerca de..." al men del sistema.

	// IDM_ABOUTBOX debe estar en el intervalo de comandos del sistema.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Establecer el icono para este cuadro de dilogo. El marco de trabajo realiza esta operacin
	//  automticamente cuando la ventana principal de la aplicacin no es un cuadro de dilogo
	SetIcon(m_hIcon, TRUE);			// Establecer icono grande
	SetIcon(m_hIcon, FALSE);		// Establecer icono pequeo

	// TODO: agregar aqu inicializacin adicional
	//Ponemos por defecto los valores
	m_ButtonTrayectoria.SetCheck(1);
	m_ButtonRectangulo.SetCheck(1);
	m_bComenzar = true;
	UpdateData(false);
	ActualizarCuadros();
	//Inicializamos la libreria de matlab para poder utilizarla
	if (!libdetectaInitialize())
	  MessageBox(_T("ERROR al inicializar la llamada de MATLAB"));
	
	//theta =[-5.557190660439 0.142628475911 0
    //     0.115215296172 5.533663392034 0
    //  1521.5431137392655 -190.250769088174 1];
	g_dbTheta[0][0] = -5.557190660439;
	g_dbTheta[0][1] = 0.142628475911;
	g_dbTheta[0][2] = 0;
	g_dbTheta[1][0] = 0.115215296172;
	g_dbTheta[1][1] = 5.533663392034;
	g_dbTheta[1][2] = 0;
	g_dbTheta[2][0] = 1521.5431137392655;
	g_dbTheta[2][1] = -190.250769088174;
	g_dbTheta[2][2] = 1;
	m_Capture=NULL;
	return TRUE;  // Devuelve TRUE  a menos que establezca el foco en un control
}

void CPlanificacion_TrayDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Si agrega un botn Minimizar al cuadro de dilogo, necesitar el siguiente cdigo
//  para dibujar el icono. Para aplicaciones MFC que utilicen el modelo de documentos y vistas,
//  esta operacin la realiza automticamente el marco de trabajo.

void CPlanificacion_TrayDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Contexto de dispositivo para dibujo

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrar icono en el rectngulo de cliente
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Dibujar el icono
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// El sistema llama a esta funcin para obtener el cursor que se muestra mientras el usuario arrastra
//  la ventana minimizada.
HCURSOR CPlanificacion_TrayDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPlanificacion_TrayDlg::OnBnClickedOk()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	//OnOK();
}

/*Funcin que habilita o deshabilita cada uno de los edit en funcin de las opciones selccionadas. Esta
funcin  tiene que ser llamada cada vez que cambia el valor de alguna seleccin, para que habilite o no
cada uno de los edit*/
void CPlanificacion_TrayDlg::ActualizarCuadros()
{
	UpdateData(TRUE); //Actualizar variables miembro
	switch (m_ButtonTrayectoria.GetCheck() )
	{
		case 1: 
			m_EditE.EnableWindow(true);
			m_EditKPX.EnableWindow(true);
			m_EditKPY.EnableWindow(true);
			m_EditKVX.EnableWindow(true);
			m_EditKVY.EnableWindow(true);
			m_EditKRHO.EnableWindow(false);
			m_EditKALFA.EnableWindow(false);
			m_EditKBETA.EnableWindow(false);
			m_EditKP.EnableWindow(false);
			break;
		default:
			m_EditE.EnableWindow(false);
			m_EditKPX.EnableWindow(false);
			m_EditKPY.EnableWindow(false);
			m_EditKVX.EnableWindow(false);
			m_EditKVY.EnableWindow(false);
			m_EditKRHO.EnableWindow(true);
			m_EditKALFA.EnableWindow(true);
			m_EditKBETA.EnableWindow(true);
			m_EditKP.EnableWindow(true);
			break;

	}	
	if (m_ButtonRectangulo.GetCheck() == 1)
	{
		m_EditL1.EnableWindow(true);
		m_EditL2.EnableWindow(true);
		m_EditRadio.EnableWindow(false);
		m_EditFrecuencia.EnableWindow(false);
		m_EditPosX.EnableWindow(false);
		m_EditPosY.EnableWindow(false);
		m_EditRaster.EnableWindow(false);
		m_CheckTray.EnableWindow(false);		
	}
	else if (m_ButtonCircun.GetCheck() == 1)
	{
		m_EditL1.EnableWindow(false);
		m_EditL2.EnableWindow(false);
		m_EditRadio.EnableWindow(true);
		m_EditFrecuencia.EnableWindow(true);
		m_EditPosX.EnableWindow(false);
		m_EditPosY.EnableWindow(false);
		m_EditRaster.EnableWindow(false);
		m_CheckTray.EnableWindow(false);
	}
	else if (m_ButtonPosicion.GetCheck() == 1)
	{
		m_EditL1.EnableWindow(false);
		m_EditL2.EnableWindow(false);
		m_EditRadio.EnableWindow(false);
		m_EditFrecuencia.EnableWindow(false);
		m_EditPosX.EnableWindow(true);
		m_EditPosY.EnableWindow(true);
		m_EditRaster.EnableWindow(false);
		m_CheckTray.EnableWindow(false);
	}
	else if (m_ButtonTray.GetCheck() == 1)
	{
		m_EditL1.EnableWindow(false);
		m_EditL2.EnableWindow(false);
		m_EditRadio.EnableWindow(false);
		m_EditFrecuencia.EnableWindow(false);
		m_EditPosX.EnableWindow(false);
		m_EditPosY.EnableWindow(false);
		m_EditRaster.EnableWindow(true);
		m_CheckTray.EnableWindow(true);
	}
	else
	{
		m_EditL1.EnableWindow(false);
		m_EditL2.EnableWindow(false);
		m_EditRadio.EnableWindow(false);
		m_EditFrecuencia.EnableWindow(false);
		m_EditPosX.EnableWindow(false);
		m_EditPosY.EnableWindow(false);
		m_EditRaster.EnableWindow(false);
		m_CheckTray.EnableWindow(false);
	}
	UpdateData(FALSE); //Pone los valores de las variables a los objetos
}
void CPlanificacion_TrayDlg::OnBnClickedRadioTrayectoria()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonTrayectoria.SetCheck(1);
	m_ButtonCamino.SetCheck(0);
	ActualizarCuadros();
}

void CPlanificacion_TrayDlg::OnBnClickedRadioCamino()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonTrayectoria.SetCheck(0);
	m_ButtonCamino.SetCheck(1);
	ActualizarCuadros();
}

void CPlanificacion_TrayDlg::OnBnClickedCancel()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	OnCancel();
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditE()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditKpx()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKPX.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("La ganancia Kpx no puede contener mas de 2 decimales"),MB_OK);
		m_EditKPX.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditKpy()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKPY.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("La ganancia Kpy no puede contener mas de 2 decimales"),MB_OK);
		m_EditKPY.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditKvx()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKVX.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("La ganancia Kvx no puede contener mas de 2 decimales"),MB_OK);
		m_EditKVX.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditKvy()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKVY.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("La ganancia Kvy no puede contener mas de 2 decimales"),MB_OK);
		m_EditKVY.SetFocus();
	}

}

void CPlanificacion_TrayDlg::OnEnKillfocusEditPeriodo()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditPeriodo.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("El periodo no puede contener mas de 2 decimales"),MB_OK);
		m_EditPeriodo.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditL1()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditRadio()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditVelocidad()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditL2()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditFrecuencia()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditFrecuencia.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("La Frecuencia no puede contener mas de 2 decimales"),MB_OK);
		m_EditFrecuencia.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnEnKillfocusEditKRHO()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKRHO.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("KRHO no puede contener mas de 2 decimales"),MB_OK);
		m_EditKRHO.SetFocus();
	}
}
void CPlanificacion_TrayDlg::OnEnKillfocusEditKALFA()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKALFA.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("KALFA no puede contener mas de 2 decimales"),MB_OK);
		m_EditKALFA.SetFocus();
	}
}
void CPlanificacion_TrayDlg::OnEnKillfocusEditKBETA()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKBETA.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("KBETA no puede contener mas de 2 decimales"),MB_OK);
		m_EditKBETA.SetFocus();
	}
}
void CPlanificacion_TrayDlg::OnEnKillfocusEditKP()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	CString szContenido;
	int nPosicion = 0;
	int nLongitud = 0;
	m_EditKP.GetWindowText(szContenido); 
	nPosicion = szContenido.Find('.',0);
	if (nPosicion != -1) //Si no tiene el punto colocado
		nLongitud = szContenido.GetLength() - nPosicion -1;
	if (nLongitud > 2)
	{
		AfxMessageBox(_T("KP no puede contener mas de 2 decimales"),MB_OK);
		m_EditKP.SetFocus();
	}
}

void CPlanificacion_TrayDlg::OnBnClickedRadioRectangulo()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonRectangulo.SetCheck(1);
	m_ButtonCircun.SetCheck(0);
	m_ButtonPosicion.SetCheck(0);
	m_ButtonTray.SetCheck(0);
	m_ButtonSeguimiento.SetCheck(0);	
	ActualizarCuadros();
}

void CPlanificacion_TrayDlg::OnBnClickedRadioCircunferencia()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonRectangulo.SetCheck(0);
	m_ButtonPosicion.SetCheck(0);
	m_ButtonCircun.SetCheck(1);
	m_ButtonTray.SetCheck(0);
	m_ButtonSeguimiento.SetCheck(0);	
	ActualizarCuadros();
}

/*Funcin que rellena la estructura de datos que tiene que enviar al Create con todos los valores referentes
a la trayectoria a generar, as como las diferentes ganancias de cada uno de los algoritmos de control*/
void CPlanificacion_TrayDlg::RellenaDatos(int nTamReferencia,float flOrientacion)
{	
	/*ensamblado de datos: Utilizamos 4 bytes para cada datos
	datos[0] = Tipo de trayectoria: 0 --> Rectangulo; 1 --> Circulo
									2 --> Pos Final;  3 --> Trayectoria
	Si es rectangulo:
		datos[1-4] = LADO1
		datos[5-8] = LADO2
	Si es circulo:
		datos[1-4] = RADIO
		datos[5-8] = FRECUENCIA
	Si es Pos final
		datos[1-4] = POSX
		datos[5-8] = POSY
	Si es trayectoria
		datos[1-4] = Tamao del vector de referencias
		datos[5-8] = Raster de la camara
	Si es trayectoria envio la orientacion del robot en la posicion 25-28
	//Ojo esta orientacion esta en radianes
	datos[9-12] = VELOCIDAD DE REFERENCIA
	datos[13-16] = Periodo de muestreo
	datos[17-20] = Posicion X inicial del robot en mm
	datos[21-24] = Posicion Y inicial del robot en mm
	datos[25-28] = Orientacin inicial del robot en grados
	datos[29] = Tipo de Control: 0 --> Punto descentralizado; 1 --> Persecucin pura
	//Si es punto descentralizado:
		datos[30-33] = Punto E
		datos[34-37] = ganancia Kpx
		datos[38-41] = ganancia Kpy
		datos[42-45] = ganancia Kvx
		datos[46-49] = ganancia Kvy
	//Si es persecucion pura
		datos[30-33] = ganancia k_rho
		datos[34-37] = ganancia k_alpha
		datos[38-41] = ganancia k_beta
		datos[42-45] = ganancia kp*/
	char chAux[10];
	UpdateData(true);
	
	if (m_ButtonRectangulo.GetCheck() ) //Rectangulo
	{
		datos[0] = 0;
		sprintf((char*)chAux,"%4d",m_nL1);
		datos[1] = chAux[0];
		datos[2] = chAux[1];
		datos[3] = chAux[2];
		datos[4] = chAux[3];
		sprintf((char*)chAux,"%4d",m_nL2);
		datos[5] = chAux[0];
		datos[6] = chAux[1];
		datos[7] = chAux[2];
		datos[8] = chAux[3];		
	}
	else if (m_ButtonCircun.GetCheck() ) //Circulo
	{
		datos[0] = 1;
		
		sprintf((char*)&chAux,"%4d",m_nRadio);
		datos[1] = chAux[0];
		datos[2] = chAux[1];
		datos[3] = chAux[2];
		datos[4] = chAux[3];
		sprintf((char*)&chAux,"%1.2f",m_flFrecuencia);
		datos[5] = chAux[0];
		datos[6] = chAux[1];
		datos[7] = chAux[2];
		datos[8] = chAux[3];		
	}
	else if (m_ButtonPosicion.GetCheck() ) //Posicion final
	{
		datos[0] = 2;
		
		sprintf((char*)&chAux,"%4d",m_nFinalX);
		datos[1] = chAux[0];
		datos[2] = chAux[1];
		datos[3] = chAux[2];
		datos[4] = chAux[3];
		sprintf((char*)&chAux,"%4d",m_nFinalY);
		datos[5] = chAux[0];
		datos[6] = chAux[1];
		datos[7] = chAux[2];
		datos[8] = chAux[3];		
	}
	else if (m_ButtonTray.GetCheck() ) {//Trayectoria
		datos[0] = 3;
		sprintf((char*)&chAux,"%4d",nTamReferencia);
		datos[1] = chAux[0];
		datos[2] = chAux[1];
		datos[3] = chAux[2];
		datos[4] = chAux[3];
		sprintf((char*)&chAux,"%4d",m_nRaster);
		datos[5] = chAux[0];
		datos[6] = chAux[1];
		datos[7] = chAux[2];
		datos[8] = chAux[3];
	}
	else 
		datos[0] = 4;
	//Velocidad de referencia
	sprintf((char*)&chAux,"%4d",m_nVelocidad);
	datos[9] = chAux[0];
	datos[10] = chAux[1];
	datos[11] = chAux[2];
	datos[12] = chAux[3];
	//Periodo de muestreo
	sprintf((char*)&chAux,"%1.2f",m_flPeriodo);
	datos[13] = chAux[0];
	datos[14] = chAux[1];
	datos[15] = chAux[2];
	datos[16] = chAux[3];
	//Posicion X inicial del Robot
	sprintf((char*)&chAux,"%4d",m_nPosX);
	datos[17] = chAux[0];
	datos[18] = chAux[1];
	datos[19] = chAux[2];
	datos[20] = chAux[3];
	//Posicion Y inicial del Robot
	sprintf((char*)&chAux,"%4d",m_nPosY);
	datos[21] = chAux[0];
	datos[22] = chAux[1];
	datos[23] = chAux[2];
	datos[24] = chAux[3];
	//Orientacion inicial del Robot
	if (m_ButtonTray.GetCheck() ) //Trayectoria
	  sprintf((char*)&chAux,"%1.2f",flOrientacion);
	else
	  sprintf((char*)&chAux,"%4d",m_nGrados);
	datos[25] = chAux[0];
	datos[26] = chAux[1];
	datos[27] = chAux[2];
	datos[28] = chAux[3];
	if (m_ButtonTrayectoria.GetCheck() ) //Control por trayectoria
	{
		datos[29] = 0;
		//Punto E
		sprintf((char*)&chAux,"%4d",m_nE);
		datos[30] = chAux[0];
		datos[31] = chAux[1];
		datos[32] = chAux[2];
		datos[33] = chAux[3];
		//KPX
		sprintf((char*)&chAux,"%1.2f",m_flKPX);
		datos[34] = chAux[0];
		datos[35] = chAux[1];
		datos[36] = chAux[2];
		datos[37] = chAux[3];
		//KPY
		sprintf((char*)&chAux,"%1.2f",m_flKPY);
		datos[38] = chAux[0];
		datos[39] = chAux[1];
		datos[40] = chAux[2];
		datos[41] = chAux[3];
		//KVX
		sprintf((char*)&chAux,"%1.2f",m_flKVX);
		datos[42] = chAux[0];
		datos[43] = chAux[1];
		datos[44] = chAux[2];
		datos[45] = chAux[3];
		//KVY
		sprintf((char*)&chAux,"%1.2f",m_flKVY);
		datos[46] = chAux[0];
		datos[47] = chAux[1];
		datos[48] = chAux[2];
		datos[49] = chAux[3];
	}
	else
	{
		datos[29] = 1;
		//krho		
		sprintf((char*)&chAux,"%1.2f",m_flKRHO);
		datos[30] = chAux[0];
		datos[31] = chAux[1];
		datos[32] = chAux[2];
		datos[33] = chAux[3];
		//kalfa
		sprintf((char*)&chAux,"%1.2f",m_flKALFA);
		datos[34] = chAux[0];
		datos[35] = chAux[1];
		datos[36] = chAux[2];
		datos[37] = chAux[3];
		//kbeta
		sprintf((char*)&chAux,"%1.2f",m_flKBETA);
		datos[38] = chAux[0];
		datos[39] = chAux[1];
		datos[40] = chAux[2];
		datos[41] = chAux[3];
		//kp
		sprintf((char*)&chAux,"%1.2f",m_flKP);
		datos[42] = chAux[0];
		datos[43] = chAux[1];
		datos[44] = chAux[2];
		datos[45] = chAux[3];
	}
	datos[50] = '\0';
}

/*Funcin que se ejecuta cuando pulsamos sobre el botn COMENZAR asociado al tipo de referencia. Cuando el
botn se pulsa se ejecuta esta funcin y lo que hace es establecer la comunicacin con el create para que 
realice la trayectoria indicada. Cuando el robot termina de realizar la trayectoria se lo informa a este PC
y automticamente copia el fichero de resultados del sistema embebido al pc, para abrir el MATLAB y as
estudiar los datos obtenidos*/
void CPlanificacion_TrayDlg::OnBnClickedButtonempezar()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	int iResult=0, nCodigo = 0;
	unsigned char recibidos[1];
	CString szAux;	
	if (m_ButtonTray.GetCheck() == 1)
	{
		MessageBox(_T("El tipo de referencia debe de ser un crculo, rectngulo o posicin final."),0,MB_ICONSTOP);
		return;
	}

	//Ya no puede activarlo mas veces. solo se permite una ejecucion
	m_ButtonComenzar.EnableWindow(false);
	m_ButtonEmpezarTray.EnableWindow(false);
	m_bComenzar = false;
	UpdateData(FALSE); //Pone los valores de las variables a los objetos
	//Rellenamos la estructura de datos
	RellenaDatos(0,0);
	//Actualizamos el edit	
	m_sResumen = _T("Ensamblado de datos OK.\r\nConectando con el servidor 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();
	BeginWaitCursor();
	// Initialize Winsock
	WSADATA wsaData;
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
	{
		m_sResumen += _T("Error al inicializar el winsock\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		EndWaitCursor();	
		return;
	}

	// Create a SOCKET for connecting to server	
	m_ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (m_ConnectSocket == INVALID_SOCKET) 
	{
		szAux.Format(_T("Error de socket(192.168.253.254) (): %ld\r\n"),WSAGetLastError() );
		m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
    // The sockaddr_in structure specifies the address family,
	// IP address, and port of the server to be connected to.
	sockaddr_in clientService; 
	clientService.sin_family = AF_INET;
	clientService.sin_addr.s_addr = inet_addr( "192.168.253.254" );
	//clientService.sin_addr.s_addr = inet_addr( "127.0.0.1" );
	clientService.sin_port = htons(PUERTO);

	//----------------------
	// Connect to server.
	if ( connect( m_ConnectSocket, (SOCKADDR*) &clientService, sizeof(clientService) ) == SOCKET_ERROR) 
	{
		m_sResumen += _T("Fallo de conexin con el servidor 192.168.253.254.\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}

	m_sResumen += _T("Connectado con el servidor.\r\nEnviando datos a 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

	//Envo el codigo 10 para indicar que quiero hacer el algoritmo
	recibidos[0] = 10;
	iResult = send( m_ConnectSocket, (char*)recibidos, 1, 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send () (192.168.253.254) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
    }
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	
	m_sResumen += _T("Cdigo de datos enviado. Esperando respuesta del 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

    // Receive until the peer closes the connection
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult > 0 )
		szAux.Format(_T("Respuesta aceptada de 192.168.253.254. Enviando paquete de datos\r\n"), iResult);
    else if ( iResult == 0 )
        szAux.Format(_T("Conexin cerrada en 192.168.253.254\r\n") );
    else
		szAux.Format(_T("Fallo de recepcin del 192.168.253.254 con error: %d\r\n"), WSAGetLastError());
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	//----------------------
    // Send an initial buffer
	//Hace falta el 0 ya quesino no salen bien los datos
    iResult = send( m_ConnectSocket, (char *)datos, sizeof(datos), 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send () (192.168.253.2549) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
    }
	if (iResult != sizeof(datos)) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d\r\nEsperando datos del 192.168.253.254...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	//Vamos a recibir mensajes de forma asincrona ya que no se cuando finaliza el proceso
	WSAAsyncSelect(m_ConnectSocket, this->m_hWnd, WM_SOCKET_CREATE, FD_READ);
	EndWaitCursor();
}

/*Esta funcin se ejecuta para refrescar todo el formulario. Esto es debido al reloj que se muestra, que produce
inconsistencias en los mensajes del formulario*/
void CPlanificacion_TrayDlg::DoEvents()
{
	MSG oMSG;
	while(::PeekMessage(&oMSG, NULL, 0, 0, PM_NOREMOVE))
	{
		if(::GetMessage(&oMSG, NULL, 0, 0))
		{
			::TranslateMessage(&oMSG);
			::DispatchMessage(&oMSG);
		}
		else
			break;
	}
}

void CPlanificacion_TrayDlg::OnBnClickedRadioPosicion()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonRectangulo.SetCheck(0);
	m_ButtonCircun.SetCheck(0);
	m_ButtonPosicion.SetCheck(1);	
	m_ButtonTray.SetCheck(0);
	m_ButtonSeguimiento.SetCheck(0);	
	ActualizarCuadros();
}


void CPlanificacion_TrayDlg::OnBnClickedRadioTray()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonRectangulo.SetCheck(0);
	m_ButtonCircun.SetCheck(0);
	m_ButtonPosicion.SetCheck(0);	
	m_ButtonSeguimiento.SetCheck(0);	
	m_ButtonTray.SetCheck(1);
	ActualizarCuadros();
}

/*Esta funcin se lanza automticamente por eventos de notificacin de mensajes cuando hemos convertido
el socket en asncrono. CUando existe informacin en el buffer del socket asociado al robot Create entonces
salta esta funcin. Bsicamente lo que se hace es leer del buffer y extraer la informacin, que ser para
indicarnos que el Create ya est preparado para empujar la pelota, cuando as se lo indique este PC*/
LRESULT CPlanificacion_TrayDlg::OnRecepcion_CREATE(WPARAM wParam, LPARAM lParam)
{
	BOOL bExito;
	DWORD Resultado;
	int iResult;
	int nLastError;
	unsigned char recibidos[1];
    PROCESS_INFORMATION piProcessInfo;
	STARTUPINFOW siStartupInfo;
	CString szAux;
	int nCodigo;
	int nSelectError = (int) WSAGETSELECTERROR (lParam);
	int nSelectEvent = (int) WSAGETSELECTEVENT (lParam);
   
   if ( (!nSelectError) && (nSelectEvent == FD_READ))
   {
		// Receive until the peer closes the connection
		iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
		if ( iResult > 0 )
	 		szAux.Format(_T("Bytes recibidos del 192.168.253.254: %d\r\n"), iResult);
		else if ( iResult == 0 ) {
			szAux.Format(_T("Conexin cerrada de 192.168.253.254\r\n") );
			m_sResumen += szAux;
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);			
			return -1;
		}
		else
		{
			szAux.Format(_T("Fallo de recepcin en 192.168.253.254 con error: %d\r\n"), WSAGetLastError());
			m_sResumen += szAux;
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);			
			return -1;
		}    
		m_sResumen += szAux;
		DoEvents();
		UpdateData(false);
		//Comprobamos si es un 1 en cuyo caso se ha producido algun error
		nCodigo = recibidos[0];
		if (nCodigo == 1)
		{
			m_sResumen += _T("El algoritmo de control no ha finalizado correctamente. Es posible que el robot se haya apagado");
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);		
			// Cerramos la conexion
			closesocket(m_ConnectSocket);
			WSACleanup();
			return -1;
		} 
		else if (nCodigo == 2)
		{
			m_sResumen += _T("Se ha realizado una parada de EMERGENCIA.\r\n");
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);
			// Cerramos la conexion
			closesocket(m_ConnectSocket);
			WSACleanup();
			return -1;
		}
		else if (nCodigo == 0)
		{
			//Se recibe el 0 leemos los datos
			m_sResumen += _T("PROCESO FINALIZADO. Procesando datos...\r\n");		
			DoEvents();
			UpdateData(false);
			
			//Abrimos el pscp para copiar el fichero al ordenador
			memset(&siStartupInfo, 0, sizeof(siStartupInfo));
			memset(&piProcessInfo, 0, sizeof(piProcessInfo));
			//bExito = CreateProcess(_T("C:\\pscp.exe"),_T(" -pw letmein -scp root@192.168.253.254:/home/root/datos.txt C:\\datos.txt"), 0, 0, false,CREATE_NEW_CONSOLE, 0, 0,&siStartupInfo, &piProcessInfo);
			bExito = CreateProcess(_T("C:\\pscp.exe"),_T(" -pw letmein -scp root@192.168.253.254:/home/root/datos.txt C:\\datos.txt"), 0, 0, false,CREATE_NO_WINDOW, 0, 0,&siStartupInfo, &piProcessInfo);
			//Espera que el programa finalice
			if (bExito) 
			{//esperamos 2 minutos
				Resultado = WaitForSingleObject(piProcessInfo.hProcess, INFINITE);
				if (Resultado == WAIT_OBJECT_0)
				{
					m_sResumen += _T("Se ha copiado el fichero de datos. Abriendo MATLAB...\r\n");
					DoEvents();
					UpdateData(false);
				}
				else
				{
					m_sResumen += _T("NO SE HA PODIDO COPIAR EL FICHERO DE RESULTADOS DE LA TARJETA POR EXCEDER TIEMPO O CERRAR EL PROGRAMA\r\n");		
					m_ButtonComenzar.EnableWindow(true);
					m_ButtonEmpezarTray.EnableWindow(true);
					m_bComenzar = true;
					DoEvents();
					UpdateData(false);
					// Cerramos la conexion
					closesocket(m_ConnectSocket);
					WSACleanup();
					return -1;
				}
			}
			else
			{
				m_sResumen += _T("NO SE HA PODIDO COPIAR EL FICHERO DE RESULTADOS DE LA TARJETA\r\n");		
				m_ButtonComenzar.EnableWindow(true);
				m_ButtonEmpezarTray.EnableWindow(true);
				m_bComenzar = true;
				DoEvents();
				UpdateData(false);
				// Cerramos la conexion
				closesocket(m_ConnectSocket);
				WSACleanup();
				return -1;
			}
			//Abrimos el matlab y ejecutamos el *.m	
			memset(&siStartupInfo, 0, sizeof(siStartupInfo));
			memset(&piProcessInfo, 0, sizeof(piProcessInfo));
			bExito = CreateProcess(_T("C:\\Program Files\\MATLAB\\R2008b\\bin\\matlab.exe"),_T(" -r datos_salida"), 0, 0, false,CREATE_NEW_CONSOLE, 0, 0,&siStartupInfo, &piProcessInfo);
			//Espera que el programa finalice
			if (bExito)//esperamos 2 minutos
				WaitForSingleObject(piProcessInfo.hProcess, INFINITE);
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);
			// Cerramos la conexion
			closesocket(m_ConnectSocket);
			WSACleanup();
			return 1;
		}
		else if (nCodigo == 60) //Para saber que nos avisa de que el create ha llegado a la posicion para
	    //empujar la pelota
		{
			// Recibo 1 byte para saber que el CREATE ha llegado a la posicion final
			g_nRecibidos++;
			if (g_nRecibidos == 1)
				szAux.Format(_T("El CREATE lleg a la posicion. Esperando a que el KOALA llegue a la posicion final\r\n"), iResult);
			else
				szAux.Format(_T("El CREATE y el KOALA ya estan en sus posiciones. procesando para empujar la pelota\r\n"), iResult);
  			m_sResumen += szAux;
			UpdateData(false);
			DoEvents();
			if (g_nRecibidos == 2)
				RecogerPelota();
			return 1;
		}
   } 
   else {   
      nLastError = WSAGetLastError(); 
	  szAux.Format(_T("Se ha activado el evento de recepcin con ERROR: %d\r\n"),nLastError);
	  m_sResumen += szAux;
	  m_ButtonComenzar.EnableWindow(true);
	  m_ButtonEmpezarTray.EnableWindow(true);
	  m_bComenzar = true;
	  DoEvents();
	  UpdateData(false);
	  // Cerramos la conexion
	  closesocket(m_ConnectSocket);
	  WSACleanup();
	  return -1;
   }
   return 0;     
}  

/*Esta funcin se lanza automticamente por eventos de notificacin de mensajes cuando hemos convertido
el socket en asncrono. Cuando existe informacin en el buffer del socket asociado al robot Koala entonces
salta esta funcin. Bsicamente lo que se hace es leer del buffer y extraer la informacin, que ser para
indicarnos que el Koala ya est en su posicin para recoger la pelota*/
LRESULT CPlanificacion_TrayDlg::OnRecepcion_KOALA(WPARAM wParam, LPARAM lParam)
{
	int iResult;
	int nLastError;
	unsigned char recibidos[1];
	CString szAux;
	int nCodigo;
	int nSelectError = (int) WSAGETSELECTERROR (lParam);
	int nSelectEvent = (int) WSAGETSELECTEVENT (lParam);
   
   if ( (!nSelectError) && (nSelectEvent == FD_READ))
   {
		// Receive until the peer closes the connection
		iResult = recv(m_ConnectSKoala, (char*)recibidos, 1, 0);
		if ( iResult > 0 )
	 		szAux.Format(_T("Bytes recibidos del 192.168.253.252: %d\r\n"), iResult);
		else if ( iResult == 0 ) {
			szAux.Format(_T("Conexin cerrada de 192.168.253.252\r\n") );
			m_sResumen += szAux;
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);			
			return -1;
		}
		else
		{
			szAux.Format(_T("Fallo de recepcin en 192.168.253.252 con error: %d\r\n"), WSAGetLastError());
			m_sResumen += szAux;
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);			
			return -1;
		}    
		m_sResumen += szAux;
		DoEvents();
		UpdateData(false);
		//Comprobamos si es un 1 en cuyo caso se ha producido algun error
		nCodigo = recibidos[0];
		if (nCodigo == 0)
		{
			m_sResumen += _T("Ha ocurrido algn error interno\r\n");
			m_ButtonComenzar.EnableWindow(true);
			m_ButtonEmpezarTray.EnableWindow(true);
			m_bComenzar = true;
			DoEvents();
			UpdateData(false);		
			// Cerramos la conexion
			closesocket(m_ConnectSKoala);
			WSACleanup();
			return -1;
		} 
		else if (nCodigo == 60) //Para saber que nos avisa de que el koala ha llegado a la posicion para
	    //empujar la pelota
		{
			// Recibo 1 byte para saber que el KOALA ha llegado a la posicion final
			g_nRecibidos++;
			if (g_nRecibidos == 1)
				szAux.Format(_T("El KOALA lleg a la posicion. Esperando a que el CREATE llegue a la posicion final\r\n"), iResult);
			else
				szAux.Format(_T("El CREATE y el KOALA ya estan en sus posiciones. procesando para empujar la pelota\r\n"), iResult);
  			m_sResumen += szAux;
			UpdateData(false);
			DoEvents();
			if (g_nRecibidos == 2)
				RecogerPelota();
			return 1;
		}
   } 
   else {   
      nLastError = WSAGetLastError(); 
	  szAux.Format(_T("Se ha activado el evento de recepcin con ERROR: %d\r\n"),nLastError);
	  m_sResumen += szAux;
	  m_ButtonComenzar.EnableWindow(true);
	  m_ButtonEmpezarTray.EnableWindow(true);
	  m_bComenzar = true;
	  DoEvents();
	  UpdateData(false);
	  // Cerramos la conexion
	  closesocket(m_ConnectSocket);
	  WSACleanup();
	  return -1;
   }
   return 0;     
}  

/*Esta funcin activa la parada de emergencia del Create. Simplemente lo que hace es enviar un comando especial
al robot para indicarle que tiene que proceder a una parada completa del algoritmo actual de ejecucin*/
void CPlanificacion_TrayDlg::OnBnClickedButtonparada()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	int iResult=0, nCodigo = 0;
	unsigned char recibidos[1];
	CString szAux;	
	if (m_bComenzar == true)
	{
		AfxMessageBox(_T("No se puede parara la ejecucin porque sta no ha empezado"));
		return;
	}
	BeginWaitCursor();
	WSADATA wsaData;
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
	{
		m_sResumen += _T("Error al inicializar el winsock\r\n");
		UpdateData(false);
		DoEvents();
		EndWaitCursor();	
		return;
	}

	// Create a SOCKET for connecting to server	
	m_SocketParada = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (m_SocketParada == INVALID_SOCKET) 
	{
		szAux.Format(_T("Error de socket(192.168.253.254) (): %ld\r\n"),WSAGetLastError() );
		m_sResumen += szAux;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
    // The sockaddr_in structure specifies the address family,
	// IP address, and port of the server to be connected to.
	sockaddr_in clientService; 
	clientService.sin_family = AF_INET;
	clientService.sin_addr.s_addr = inet_addr( "192.168.253.254" );
	//clientService.sin_addr.s_addr = inet_addr( "127.0.0.1" );
	clientService.sin_port = htons(PUERTO);

	//----------------------
	// Connect to server.
	if ( connect( m_SocketParada, (SOCKADDR*) &clientService, sizeof(clientService) ) == SOCKET_ERROR) 
	{
		m_sResumen += _T("Fallo de conexin con el servidor 192.168.253.254.\r\n");
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}

	m_sResumen += _T("Connectado con el servidor.\r\nEnviando datos a 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

	//Envo el codigo 20 para indicar que quiero hacer una parada de emergencia
	recibidos[0] = 20;
	iResult = send( m_SocketParada, (char*)recibidos, 1, 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send () (192.168.253.254) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		UpdateData(false);
		DoEvents();
        closesocket(m_SocketParada);
        WSACleanup();
		EndWaitCursor();
        return;
    }
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		UpdateData(false);
		DoEvents();
        closesocket(m_SocketParada);
        WSACleanup();
		EndWaitCursor();
        return;
	}

	m_sResumen += _T("Cdigo de datos enviado. Esperando respuesta del 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
    closesocket(m_SocketParada);
    WSACleanup();
	EndWaitCursor();
}

/*Esta funcin se conecta con el Create para indicarle que haga el algoritmo de control seleccionado con 
el objetivo de seguir la trayectoria generada por MATLAB con evitacin de obstculos*/ 
void CPlanificacion_TrayDlg::OnBnClickedButtonempezartray()
{
	UpdateData(true);

	mwArray salX,salY,tvisu(m_nTray), error, orientacion;
	mwArray raster((double)m_nRaster);
	int lenX=0, lenY=0, nCont = 0, nResult=0;
	int *nSalX=NULL, *nSalY=NULL;
	float *flOrientacion;
	int *nError;
	int iResult=0, nCodigo = 0, nLongitud;
	unsigned char recibidos[1];
	CString szAux;	
	unsigned char *Referencias;	
	unsigned char chAux[5];	
	IplImage* img;
	//Solo puedo ejecutarlo cuando esta puesto trayectoria
	if (m_ButtonTray.GetCheck() != 1)
	{
		MessageBox(_T("Debe de estar seleccionado 'Trayectoria' para ejecutar esta opcin"),0,MB_ICONSTOP);
		return;
	}
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	BeginWaitCursor();		
	m_Capture = cvCaptureFromCAM(CV_CAP_ANY);	
	img = cvQueryFrame(m_Capture);	
	//Borramos el fichero que habia
	remove("temp.bmp");
	nResult = cvSaveImage("temp.bmp",img);
	if (nResult != 1)
	{
		MessageBox(_T("ERROR. No se ha podido salvar la imagen"),0,MB_ICONSTOP);
		EndWaitCursor();
		cvReleaseCapture(&m_Capture);
		return;
	}		
	cvReleaseCapture(&m_Capture);
	//LO PRIMERO DE TODO ES OBTENER LA TRAYECTORIA
	detecta(4,salX,salY,error,orientacion,tvisu,raster);
	//Obtenemos el codigo para saber si hay error
	nError  = (int *)malloc(sizeof(int));
	error.GetData(nError,1);
	if (nError[0]== -10)
	{
		MessageBox(_T("ERROR. Se ha detectado mas de una posicion inicial o ninguna"),0,MB_ICONSTOP);
		EndWaitCursor();
		return;
	}
	if (nError[0] == -20)
	{
		MessageBox(_T("ERROR. Se ha detectado mas de una posicion final o ninguna"),0,MB_ICONSTOP);
		EndWaitCursor();
		return;
	}
	//Obtenemos la longitud de los vectores
	lenX=salX.NumberOfElements();
	lenY=salY.NumberOfElements();
	if (lenX != lenY)
	{
		MessageBox(_T("ERROR. Los tamaos de los vectores de salida NO coinciden"),0,MB_ICONSTOP);
		EndWaitCursor();
		return;
	}	
	//Ya no puede activarlo mas veces. solo se permite una ejecucion
	m_ButtonComenzar.EnableWindow(false);
	m_bComenzar = false;
	UpdateData(FALSE); //Pone los valores de las variables a los objetos
	flOrientacion  = (float *)malloc(sizeof(int));
	orientacion.GetData(flOrientacion,1);
	//Rellenamos la estructura de datos
	RellenaDatos(lenX,flOrientacion[0]);
	//Actualizamos el edit	
	m_sResumen = _T("Ensamblado de datos OK.\r\nConectando con el servidor 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();
	// Initialize Winsock
	WSADATA wsaData;
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
	{
		m_sResumen += _T("Error al inicializar el winsock\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		EndWaitCursor();	
		return;
	}

	// Create a SOCKET for connecting to server	
	m_ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (m_ConnectSocket == INVALID_SOCKET) 
	{
		szAux.Format(_T("Error de socket(192.168.253.254) (): %ld\r\n"),WSAGetLastError() );
		m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
	sockaddr_in clientService; 
	clientService.sin_family = AF_INET;
	clientService.sin_addr.s_addr = inet_addr( "192.168.253.254" );
	//clientService.sin_addr.s_addr = inet_addr( "127.0.0.1" );
	clientService.sin_port = htons(PUERTO);
	// Connect to server.
	if ( connect( m_ConnectSocket, (SOCKADDR*) &clientService, sizeof(clientService) ) == SOCKET_ERROR) 
	{
		m_sResumen += _T("Fallo de conexin con el servidor 192.168.253.254.\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}

	m_sResumen += _T("Connectado con el servidor.\r\nEnviando datos a 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

	//PARTE 1. ENVIO DE CODIGO 30 PARA SABER QUE VAMOS A SEGUIR UNA REFERENCIA CON LA CAMARA 
	recibidos[0] = 30;
	iResult = send( m_ConnectSocket, (char*)recibidos, 1, 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send () (192.168.253.254) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
    }
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
	}	
	m_sResumen += _T("Cdigo de datos enviado. Esperando respuesta del 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();

    //PARTE 1. RECEPCIN. SI LLEGA BIEN SEGUIMOS PARA ENVIAR EL PAQUETE DE DATOS
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult > 0 )
		szAux.Format(_T("Respuesta aceptada de 192.168.253.254. Enviando paquete de datos\r\n"), iResult);
    else if ( iResult == 0 )
        szAux.Format(_T("Conexin cerrada en 192.168.253.254\r\n") );
    else
		szAux.Format(_T("Fallo de recepcin del 192.168.253.254 con error: %d\r\n"), WSAGetLastError());
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	//PARTE 2. ENVIAMOS EL PAQUETE DE DATOS. TAMBIEN CONTIENE CUAL VA A SER EL TAMAO DEL VECTOR DE REFERENCIAS
    iResult = send( m_ConnectSocket, (char *)datos, sizeof(datos), 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send () (192.168.253.2549) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
    }
	if (iResult != sizeof(datos)) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d\r\nEsperando aceptacin del 192.168.253.254...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
    
	// PARTE 2. RECEPCIN. SI TODO VA BIEN ENVIAMOS LA PARTE 3 QUE ES EL VECTOR DE REFERENCIAS
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult > 0 )
		szAux.Format(_T("Parte 2 aceptada de 192.168.253.254. Enviando paquete de referencia\r\n"), iResult);
    else if ( iResult == 0 )
        szAux.Format(_T("Conexin cerrada en 192.168.253.254\r\n") );
    else
		szAux.Format(_T("Fallo de recepcin del 192.168.253.254 con error: %d\r\n"), WSAGetLastError());
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	//Creamos las referencias
	nSalX  = (int *)malloc(lenX * sizeof(int));
	nSalY  = (int *)malloc(lenY * sizeof(int));
	salX.GetData(nSalX,lenX);	
	salY.GetData(nSalY,lenY);	
	//El vector de referencias lo creamos nosotros
	//Por cada entero utilizamos 4 bytes. 
	//La estructura es simple. Primero las componentes X y luego las Y
	Referencias = (unsigned char *)malloc( (4*(lenX+lenY))+1 * sizeof(unsigned char));
	//COMPONENTES X
	for (nCont = 0; nCont < lenX; nCont ++)
	{
		sprintf((char*)&chAux,"%4d",nSalX[nCont]);
		nLongitud = nCont*4;
		Referencias[nLongitud]     = chAux[0];
		Referencias[nLongitud+1] = chAux[1];
		Referencias[nLongitud+2] = chAux[2];
		Referencias[nLongitud+3] = chAux[3];
	}
	//COMPONENTES Y
	for (nCont = 0; nCont < lenY; nCont ++)
	{
		nLongitud = (4 * lenX) + (nCont*4);
		sprintf((char*)&chAux,"%4d",nSalY[nCont]);
		Referencias[nLongitud]     = chAux[0];
		Referencias[nLongitud+1] = chAux[1];
		Referencias[nLongitud+2] = chAux[2];
		Referencias[nLongitud+3] = chAux[3];
	}
	nLongitud = 4 * (lenX+lenY);
	Referencias[nLongitud] = '\0';
	//PARTE 3. ENVIAMOS LAS REFERENCIAS A SEGUIR
    iResult = send( m_ConnectSocket, (char *)Referencias, nLongitud+1, 0 );
    if (iResult == SOCKET_ERROR) {
		szAux.Format(_T("Fallo de send() de referencias (192.168.253.2549) con error: %d\r\n"), WSAGetLastError() );
        m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
		free(Referencias);
		free(nSalX);
		free(nSalY);
        return;
    }
	if (iResult != (nLongitud+1) ) {
        m_sResumen += _T("No se han podido enviar todos los bytes de referencias al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
        WSACleanup();
		EndWaitCursor();
		free(Referencias);
		free(nSalX);
		free(nSalY);
        return;
	}
	szAux.Format(_T("Bytes de referencias enviados: %d\r\nEsperando aceptacin del 192.168.253.254...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	free(Referencias);
	free(nSalX);
	free(nSalY);
	//Vamos a recibir mensajes de forma asincrona ya que no se cuando finaliza el proceso
	WSAAsyncSelect(m_ConnectSocket, this->m_hWnd, WM_SOCKET_CREATE, FD_READ);
	EndWaitCursor();
}


/*esta funcin es la que activa el trabajo coordinado por ambos robots. Bsicamente lo que hace con OPENCV
es obtener la imagen de la cmara, extrae posiciones inciales y finales e indica a ambos robots que vayan s
sus posiciones para recoger la pelota. Finalmente hacemos el socket asncrono para seguir con la programacion
cuando recibamos los mensajes de ambos robots*/
void CPlanificacion_TrayDlg::OnBnClickedButtonsigue()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	int iResult=0, nCodigo = 0;
	unsigned char recibidos[1];
	CString szAux;	
	IplImage* img;
	unsigned char chAux[10];
	unsigned char datosRef[43];
	bool bEmpieza = false;
	//Orientacin final del create es 0
	float flOrIniCrea = 0, flOrIniKoa = 0;
	//Orientacin final del koala es Pi. No se pone exactamente Pi pq produce problemas
	float flOrFinCrea = (float)0.0, flOrFinKoa = (float)3.13;
	int nPosIniXCrea = 0, nPosIniYCrea = 0, nPosFinXCrea=0, nPosFinYCrea=0;
	int nPosIniXKoa = 0, nPosIniYKoa = 0, nPosFinXKoa=0, nPosFinYKoa=0;
	int nPosFinX=0,nPosFinY=0;

	if (m_ButtonSeguimiento.GetCheck() != 1)
	{
		MessageBox(_T("Debe de estar seleccionado Seguimiento Trayectoria para ejecutar esta opcin."),0,MB_ICONSTOP);
		return;
	}
	//Cuando esta variable vaga 2 significa que los dos robots han llegado a su posicion
	g_nRecibidos = 0;
	//Ya no puede activarlo mas veces. solo se permite una ejecucion
	m_ButtonComenzar.EnableWindow(false);
	m_ButtonEmpezarTray.EnableWindow(false);
	m_bComenzar = false;
	UpdateData(FALSE); //Pone los valores de las variables a los objetos

	bEmpieza=false;
	m_Capture = cvCaptureFromCAM(CV_CAP_ANY);	
	//PARTE 1. TRATAMIENTO DE LA IMAGEN
	while (bEmpieza != true)
	{
		img = cvQueryFrame(m_Capture);				
		cvShowImage("WebCam",img);
		cvWaitKey(10);
		bEmpieza = CalculaImagen(img,nPosIniXCrea,nPosIniYCrea,flOrIniCrea,nPosIniXKoa,nPosIniYKoa,flOrIniKoa,nPosFinX,nPosFinY);
	}
	//Rellenamos la estructura de datos
	RellenaDatos(0,0);
	//Actualizamos el edit	
	m_sResumen = _T("Ensamblado de datos OK.\r\nConectando con el servidor 192.168.253.254 (CREATE...\r\n");
	UpdateData(false);
	DoEvents();
	BeginWaitCursor();
	// Initialize Winsock
	WSADATA wsaData;
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
	{
		m_sResumen += _T("Error al inicializar el winsock\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		EndWaitCursor();	
		return;
	}

	// PARTE 2. Conexion con el CREATE
	m_ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (m_ConnectSocket == INVALID_SOCKET) 
	{
		szAux.Format(_T("Error de socket(192.168.253.254) (): %ld\r\n"),WSAGetLastError() );
		m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
    // The sockaddr_in structure specifies the address family,
	// IP address, and port of the server to be connected to.
	sockaddr_in clientService; 
	clientService.sin_family = AF_INET;
	clientService.sin_addr.s_addr = inet_addr( "192.168.253.254" );	
	//clientService.sin_addr.s_addr = inet_addr( "127.0.0.1" );	
	clientService.sin_port = htons(PUERTO);

	if ( connect( m_ConnectSocket, (SOCKADDR*) &clientService, sizeof(clientService) ) == SOCKET_ERROR) 
	{
		m_sResumen += _T("Fallo de conexin con el servidor 192.168.253.254.\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}

	m_sResumen += _T("Connectado con el servidor CREATE. Conectando con el servidor (192.168.253.252) KOALA...");
	UpdateData(false);
	DoEvents();

	// PARTE 3. Conexion con el KOALA
	m_ConnectSKoala = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (m_ConnectSKoala == INVALID_SOCKET) 
	{
		szAux.Format(_T("Error de socket(192.168.253.252) (KOALA): %ld\r\n"),WSAGetLastError() );
		m_sResumen += szAux;
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
    // The sockaddr_in structure specifies the address family,
	// IP address, and port of the server to be connected to.
	sockaddr_in clientService2; 
	clientService2.sin_family = AF_INET;
	clientService2.sin_addr.s_addr = inet_addr( "192.168.253.252" );	
	clientService2.sin_port = htons(PUERTO2);

	if ( connect( m_ConnectSKoala, (SOCKADDR*) &clientService2, sizeof(clientService2) ) == SOCKET_ERROR) 
	{
		m_sResumen += _T("Fallo de conexin con el servidor 192.168.253.252.\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
		WSACleanup();
		EndWaitCursor();
		return;
	}
	
	m_sResumen += _T("Connectado con el servidor KOALA. Enviando datos al CREATE...");
	UpdateData(false);
	DoEvents();

	//PARTE 4. Envo el codigo 50 al CREATE para indicar que quiero hacer el algoritmo de recoger la pelota
	recibidos[0] = 50;
	iResult = send( m_ConnectSocket, (char*)recibidos, 1, 0 );
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	
	m_sResumen += _T("Cdigo de datos enviado. Esperando respuesta del 192.168.253.254...\r\n");
	UpdateData(false);
	DoEvents();
	
    // PARTE 5. Recibo 1 byte para saber que todo ha ido bien
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult == 1)
		szAux.Format(_T("Respuesta aceptada de 192.168.253.254. Enviando Cdigo de datos al KOALA\r\n"), iResult);
	else {
        szAux.Format(_T("Fallo de recepcin en 192.168.253.254\r\n") );
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	//PARTE 6. Envo el codigo 50 al KOALA para indicar que quiero hacer el algoritmo de recoger la pelota
	recibidos[0] = 50;
	iResult = send( m_ConnectSKoala, (char*)recibidos, 1, 0 );
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.252\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	
	m_sResumen += _T("Cdigo de datos enviado. Esperando respuesta del 192.168.253.252...\r\n");
	UpdateData(false);
	DoEvents();

    //PARTE 7. Recibo 1 byte para saber que todo ha ido bien
    iResult = recv(m_ConnectSKoala, (char*)recibidos, 1, 0);
    if ( iResult == 1)
		szAux.Format(_T("Respuesta aceptada de 192.168.253.252. Enviando datos al CREATE\r\n"), iResult);
	else {
        szAux.Format(_T("Fallo de recepcin en 192.168.253.252\r\n") );
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
		
	//PARTE 8. Enviamos al create los datos de los algoritmos
    iResult = send( m_ConnectSocket, (char *)datos, sizeof(datos), 0 );
	if (iResult != sizeof(datos)) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d\r\nEnviando datos de posiciones al 192.168.253.254...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	
	//datos para enviar al CREATE
	sprintf((char*)&chAux,"%7d",nPosIniXCrea);
	datosRef[0] = chAux[0];
	datosRef[1] = chAux[1];
	datosRef[2] = chAux[2];
	datosRef[3] = chAux[3];
	datosRef[4] = chAux[4];
	datosRef[5] = chAux[5];
	datosRef[6] = chAux[6];
	sprintf((char*)&chAux,"%7d",nPosIniYCrea);
	datosRef[7] = chAux[0];
	datosRef[8] = chAux[1];
	datosRef[9] = chAux[2];
	datosRef[10] = chAux[3];
	datosRef[11] = chAux[4];
	datosRef[12] = chAux[5];
	datosRef[13] = chAux[6];
	sprintf((char*)&chAux,"%07.4f",flOrIniCrea);
	datosRef[14] = chAux[0];
	datosRef[15] = chAux[1];
	datosRef[16] = chAux[2];
	datosRef[17] = chAux[3];
	datosRef[18] = chAux[4];
	datosRef[19] = chAux[5];
	datosRef[20] = chAux[6];
	//Quitamos 300 mm
	nPosFinXCrea = nPosFinX - 200;	
	sprintf((char*)&chAux,"%7d",nPosFinXCrea);
	datosRef[21] = chAux[0];
	datosRef[22] = chAux[1];
	datosRef[23] = chAux[2];
	datosRef[24] = chAux[3];
	datosRef[25] = chAux[4];
	datosRef[26] = chAux[5];
	datosRef[27] = chAux[6];
	//Este valor es el mismo
	nPosFinYCrea = nPosFinY;
	sprintf((char*)&chAux,"%7d",nPosFinYCrea);
	datosRef[28] = chAux[0];
	datosRef[29] = chAux[1];
	datosRef[30] = chAux[2];
	datosRef[31] = chAux[3];
	datosRef[32] = chAux[4];
	datosRef[33] = chAux[5];
	datosRef[34] = chAux[6];
	sprintf((char*)&chAux,"%07.4f",flOrFinCrea);
	datosRef[35] = chAux[0];
	datosRef[36] = chAux[1];
	datosRef[37] = chAux[2];
	datosRef[38] = chAux[3];
	datosRef[39] = chAux[4];
	datosRef[40] = chAux[5];
	datosRef[41] = chAux[6];
	datosRef[42] = '\0';	

	//PARTE 9. Envio sincrono de los 6 datos que son x,y,o inicial y x,y,o final calculados	--> Para el create
    iResult = send( m_ConnectSocket, (char *)datosRef, sizeof(datosRef), 0 );
	if (iResult != sizeof(datosRef)) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d de posicion inicial y final precalculados\r\nEnviando datos de posiciones al KOALA...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	//datos para enviar al KOALA
	sprintf((char*)&chAux,"%7d",nPosIniXKoa);
	datosRef[0] = chAux[0];
	datosRef[1] = chAux[1];
	datosRef[2] = chAux[2];
	datosRef[3] = chAux[3];
	datosRef[4] = chAux[4];
	datosRef[5] = chAux[5];
	datosRef[6] = chAux[6];
	sprintf((char*)&chAux,"%7d",nPosIniYKoa);
	datosRef[7] = chAux[0];
	datosRef[8] = chAux[1];
	datosRef[9] = chAux[2];
	datosRef[10] = chAux[3];
	datosRef[11] = chAux[4];
	datosRef[12] = chAux[5];
	datosRef[13] = chAux[6];
	sprintf((char*)&chAux,"%07.4f",flOrIniKoa);
	datosRef[14] = chAux[0];
	datosRef[15] = chAux[1];
	datosRef[16] = chAux[2];
	datosRef[17] = chAux[3];
	datosRef[18] = chAux[4];
	datosRef[19] = chAux[5];
	datosRef[20] = chAux[6];
	//Aadimos 300 mm
	nPosFinXKoa = nPosFinX + 400;
	sprintf((char*)&chAux,"%7d",nPosFinXKoa);
	datosRef[21] = chAux[0];
	datosRef[22] = chAux[1];
	datosRef[23] = chAux[2];
	datosRef[24] = chAux[3];
	datosRef[25] = chAux[4];
	datosRef[26] = chAux[5];
	datosRef[27] = chAux[6];
	//Este valor es el mismo
	nPosFinYKoa = nPosFinY;
	sprintf((char*)&chAux,"%7d",nPosFinYKoa);
	datosRef[28] = chAux[0];
	datosRef[29] = chAux[1];
	datosRef[30] = chAux[2];
	datosRef[31] = chAux[3];
	datosRef[32] = chAux[4];
	datosRef[33] = chAux[5];
	datosRef[34] = chAux[6];
	sprintf((char*)&chAux,"%07.4f",flOrFinKoa);
	datosRef[35] = chAux[0];
	datosRef[36] = chAux[1];
	datosRef[37] = chAux[2];
	datosRef[38] = chAux[3];
	datosRef[39] = chAux[4];
	datosRef[40] = chAux[5];
	datosRef[41] = chAux[6];
	datosRef[42] = '\0';	

	//PARTE 10. Envio sincrono de los 6 datos que son x,y,o inicial y x,y,o final calculados	--> Para el KOALA
    iResult = send( m_ConnectSKoala, (char *)datosRef, sizeof(datosRef), 0 );
	if (iResult != sizeof(datosRef)) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.252\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d de posicion inicial y final precalculados\r\nEsperando que el CREATE o KOALA llegue a la posicion final...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
    //Esta parte es asincrona. Como no se cual llega antes, recogo esa informacion con paso de mensajes	
	WSAAsyncSelect(m_ConnectSocket, this->m_hWnd, WM_SOCKET_CREATE, FD_READ);
	WSAAsyncSelect(m_ConnectSKoala, this->m_hWnd, WM_SOCKET_KOALA, FD_READ);
}


void CPlanificacion_TrayDlg::OnBnClickedRadioSeguimiento()
{
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	UpdateData(true);
	m_ButtonRectangulo.SetCheck(0);
	m_ButtonCircun.SetCheck(0);
	m_ButtonPosicion.SetCheck(0);	
	m_ButtonSeguimiento.SetCheck(1);	
	m_ButtonTray.SetCheck(0);
	ActualizarCuadros();
}

/*esta funcin es la que calcula las posiciones y orientaciones iniciales de los dos robots y la posicin
final de donde tiene que llegar. Para ello hace uso de OPENCV y obtiene la imagen, realiza varias segmentaciones
en funcin de los tres componentes que se quieren calcular, los procesa y envia estos datos por los
parmetros de referencia*/
bool CalculaImagen(IplImage* imgOriginal,
				   int &nPosIniXCrea,int &nPosIniYCrea,float &flOrIniCrea,
				   int &nPosIniXKoa,int &nPosIniYKoa,float &flOrIniKoa,int &nPosFinX,int &nPosFinY)
{
	IplImage* imgAux;
	IplImage* imgAux2;
	IplConvKernel* filtro;
	int nContornos=0;
	CvSeq* contour=0;
	CvMemStorage* storage = cvCreateMemStorage(0);
	uchar *aPixelIn;
	int R=0, G=0, B=0;
	int acumX=0,acumY=0,acum=0,centroidePixelX,centroidePixelY;
	int i = 0, j=0;
	float dist=0, distAux;
	int distX=0, distY=0;
	int plejanoPixelX,plejanoPixelY, plejanoX, plejanoY;		

	//PARTE 1 DETECCION DEL ORIGEN. COLOR NEGRO
	aPixelIn = (uchar *)imgOriginal->imageData;
	imgAux=cvCreateImage(cvSize(imgOriginal->width,imgOriginal->height),8,1);	
	for(i = 0; i < imgOriginal->height; i++)
		for(j = 0; j < imgOriginal->width; j++)
		{
			B = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+0];
			G = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+1];
			R = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+2];
			if ((B<70) && (R<70) && (G<70))
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = (uchar)255;
			else
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = 0;
		}			
	//Hacemos erosion
	//matriz de 3 x 3 y es un rectangulo
	filtro = cvCreateStructuringElementEx(2,2,0,0,CV_SHAPE_RECT,NULL);
	//2 es el numero de ietraciones
	cvErode(imgAux,imgAux,filtro,3);
	//Hacemos un poco de dilatacion	
	cvDilate(imgAux,imgAux,filtro,3);
	//Ahora 
	imgAux2=cvCloneImage(imgAux);
	nContornos = cvFindContours(imgAux2,storage,&contour);
	if (nContornos == 1)
	{
		cvDrawContours(imgAux2,contour,cvScalarAll(255),cvScalarAll(255),100);			
		cvWaitKey(33);
		//calculamos el centroide de la imgAux.
		acum=0;
		acumX=0;
		acumY=0;
		aPixelIn = (uchar *)imgAux->imageData;
		for(i = 0; i < imgAux->height; i++)
			for(j = 0; j < imgAux->width; j++)
			{
				if (aPixelIn[i*imgAux->widthStep+j*imgAux->nChannels+0] == 255)
				{
					acumX += i;
					acumY += j;
					acum++;
				}
			}
		if (acum != 0)
		{
			centroidePixelX = (int)((float)acumX/(float)acum);
			centroidePixelY = (int)((float)acumY/(float)acum);
			//calculamos el punto mas lejano del perimtro al centroide
			dist=0;
			distAux=0;
			plejanoPixelX = 0;
			plejanoPixelY = 0;
			for(i = 0; i < imgAux2->height; i++)
				for(j = 0; j < imgAux2->width; j++)
				{
					//Si es perimetro
					if (aPixelIn[i*imgAux2->widthStep+j*imgAux2->nChannels+0] == 255)
					{
						distX = i - centroidePixelX;
						distY = j - centroidePixelY;
						distAux = sqrt((float)((distX*distX)+(distY*distY)));
						if (distAux > dist)
						{
							dist = distAux;
							plejanoPixelX = i;
							plejanoPixelY = j;
						}
					}
				}
			//Dibujamos la linea
			cvLine(imgAux,cvPoint(centroidePixelY,centroidePixelX),cvPoint(plejanoPixelY,plejanoPixelX),CV_RGB(0,0,0));
			cvShowImage("Create",imgAux);
			cvWaitKey(33);
			//calculamos las coordenadas en x,y del posinicial
			nPosIniXCrea = (int)((g_dbTheta[0][0]*centroidePixelY)+(g_dbTheta[1][0]*centroidePixelX)+g_dbTheta[2][0]);
			nPosIniYCrea = (int)((g_dbTheta[0][1]*centroidePixelY)+(g_dbTheta[1][1]*centroidePixelX)+g_dbTheta[2][1]);
			//calculamos las coordenadas en x,y del punto lejano
			plejanoX = (int)((g_dbTheta[0][0]*plejanoPixelY)+(g_dbTheta[1][0]*plejanoPixelX)+g_dbTheta[2][0]);
			plejanoY = (int)((g_dbTheta[0][1]*plejanoPixelY)+(g_dbTheta[1][1]*plejanoPixelX)+g_dbTheta[2][1]);
			//Calculamos el angulo en radianes
			flOrIniCrea=atan2((float)(plejanoY-nPosIniYCrea),(float)(plejanoX-nPosIniXCrea));			
		}
		else
			return false;
	}
	else
		return false;
	
	//PARTE 2 DETECCION DEL DESTINO. COLOR ROJO
	aPixelIn = (uchar *)imgOriginal->imageData;
	imgAux=cvCreateImage(cvSize(imgOriginal->width,imgOriginal->height),8,1);	
	for(i = 0; i < imgOriginal->height; i++)
		for(j = 0; j < imgOriginal->width; j++)
		{
			B = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+0];
			G = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+1];
			R = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+2];
			if ((R<=255) && (R>=130) && (G<=90) && (G>=10) && (B<=90) && (B>=10) )
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = (uchar)255;
			else
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = 0;
		}			
	//Hacemos erosion
	//matriz de 3 x 3 y es un rectangulo
	filtro = cvCreateStructuringElementEx(2,2,0,0,CV_SHAPE_RECT,NULL);
	//2 es el numero de ietraciones
	cvErode(imgAux,imgAux,filtro,3);
	//Hacemos un poco de dilatacion	
	cvDilate(imgAux,imgAux,filtro,6);
	//Ahora 
	imgAux2=cvCloneImage(imgAux);
	nContornos = cvFindContours(imgAux2,storage,&contour);
	if (nContornos == 1)
	{
		cvDrawContours(imgAux2,contour,cvScalarAll(255),cvScalarAll(255),100);			
		cvWaitKey(33);
		//calculamos el centroide de la imgAux.
		acum=0;
		acumX=0;
		acumY=0;
		aPixelIn = (uchar *)imgAux->imageData;
		for(i = 0; i < imgAux->height; i++)
			for(j = 0; j < imgAux->width; j++)
			{
				if (aPixelIn[i*imgAux->widthStep+j*imgAux->nChannels+0] == 255)
				{
					acumX += i;
					acumY += j;
					acum++;
				}
			}
		if (acum != 0)
		{
			centroidePixelX = (int)((float)acumX/(float)acum);
			centroidePixelY = (int)((float)acumY/(float)acum);
			//calculamos el punto mas lejano del perimtro al centroide
			dist=0;
			distAux=0;
			plejanoPixelX = 0;
			plejanoPixelY = 0;
			for(i = 0; i < imgAux2->height; i++)
				for(j = 0; j < imgAux2->width; j++)
				{
					//Si es perimetro
					if (aPixelIn[i*imgAux2->widthStep+j*imgAux2->nChannels+0] == 255)
					{
						distX = i - centroidePixelX;
						distY = j - centroidePixelY;
						distAux = sqrt((float)((distX*distX)+(distY*distY)));
						if (distAux > dist)
						{
							dist = distAux;
							plejanoPixelX = i;
							plejanoPixelY = j;
						}
					}
				}
			//Dibujamos la linea
			//cvLine(imgAux,cvPoint(centroidePixelY,centroidePixelX),cvPoint(plejanoPixelY,plejanoPixelX),CV_RGB(0,0,0));
			cvShowImage("Pos. Final",imgAux);
			cvWaitKey(33);
			//calculamos las coordenadas en x,y del posinicial
			nPosFinX = (int)((g_dbTheta[0][0]*centroidePixelY)+(g_dbTheta[1][0]*centroidePixelX)+g_dbTheta[2][0]);
			nPosFinY = (int)((g_dbTheta[0][1]*centroidePixelY)+(g_dbTheta[1][1]*centroidePixelX)+g_dbTheta[2][1]);
			//calculamos las coordenadas en x,y del punto lejano
			plejanoX = (int)((g_dbTheta[0][0]*plejanoPixelY)+(g_dbTheta[1][0]*plejanoPixelX)+g_dbTheta[2][0]);
			plejanoY = (int)((g_dbTheta[0][1]*plejanoPixelY)+(g_dbTheta[1][1]*plejanoPixelX)+g_dbTheta[2][1]);
			//return true;
		}
		else
			return false;
	}
	else
		return false;

	//PARTE 3 DETECCION DEL KOALA. COLOR VERDE 
	aPixelIn = (uchar *)imgOriginal->imageData;
	imgAux=cvCreateImage(cvSize(imgOriginal->width,imgOriginal->height),8,1);	
	for(i = 0; i < imgOriginal->height; i++)
		for(j = 0; j < imgOriginal->width; j++)
		{
			B = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+0];
			G = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+1];
			R = aPixelIn[i*imgOriginal->widthStep+j*imgOriginal->nChannels+2];
			//if ((R<=60) && (R>=25) && (G<=110) && (G>=80) && (B<=90) && (B>=60) )
			//Para imagenes claras
			//if ((R<=256) && (R>=240) && (G<=256) && (G>=240) && (B<=180) && (B>=100) )
			if ((R<=256) && (R>=200) && (G<=256) && (G>=200) && (B<=180) && (B>=80) )
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = (uchar)255;
			else
				(imgAux->imageData + i*imgAux->widthStep)[j*imgAux->nChannels] = 0;
		}			
	//Hacemos erosion
	//matriz de 3 x 3 y es un rectangulo
	filtro = cvCreateStructuringElementEx(2,2,0,0,CV_SHAPE_RECT,NULL);
	//2 es el numero de ietraciones
	cvErode(imgAux,imgAux,filtro,3);
	//Hacemos un poco de dilatacion	
	cvDilate(imgAux,imgAux,filtro,6);
	//Ahora 
	imgAux2=cvCloneImage(imgAux);
	nContornos = cvFindContours(imgAux2,storage,&contour);
	if (nContornos == 1)
	{
		cvDrawContours(imgAux2,contour,cvScalarAll(255),cvScalarAll(255),100);			
		cvWaitKey(33);
		//calculamos el centroide de la imgAux.
		acum=0;
		acumX=0;
		acumY=0;
		aPixelIn = (uchar *)imgAux->imageData;
		for(i = 0; i < imgAux->height; i++)
			for(j = 0; j < imgAux->width; j++)
			{
				if (aPixelIn[i*imgAux->widthStep+j*imgAux->nChannels+0] == 255)
				{
					acumX += i;
					acumY += j;
					acum++;
				}
			}
		if (acum != 0)
		{
			centroidePixelX = (int)((float)acumX/(float)acum);
			centroidePixelY = (int)((float)acumY/(float)acum);
			//calculamos el punto mas lejano del perimtro al centroide
			dist=0;
			distAux=0;
			plejanoPixelX = 0;
			plejanoPixelY = 0;
			for(i = 0; i < imgAux2->height; i++)
				for(j = 0; j < imgAux2->width; j++)
				{
					//Si es perimetro
					if (aPixelIn[i*imgAux2->widthStep+j*imgAux2->nChannels+0] == 255)
					{
						distX = i - centroidePixelX;
						distY = j - centroidePixelY;
						distAux = sqrt((float)((distX*distX)+(distY*distY)));
						if (distAux > dist)
						{
							dist = distAux;
							plejanoPixelX = i;
							plejanoPixelY = j;
						}
					}
				}
			//Dibujamos la linea
			cvLine(imgAux,cvPoint(centroidePixelY,centroidePixelX),cvPoint(plejanoPixelY,plejanoPixelX),CV_RGB(0,0,0));
			cvShowImage("Koala",imgAux);
			cvWaitKey(33);
			//calculamos las coordenadas en x,y del posinicial
			nPosIniXKoa = (int)((g_dbTheta[0][0]*centroidePixelY)+(g_dbTheta[1][0]*centroidePixelX)+g_dbTheta[2][0]);
			nPosIniYKoa = (int)((g_dbTheta[0][1]*centroidePixelY)+(g_dbTheta[1][1]*centroidePixelX)+g_dbTheta[2][1]);
			//calculamos las coordenadas en x,y del punto lejano
			plejanoX = (int)((g_dbTheta[0][0]*plejanoPixelY)+(g_dbTheta[1][0]*plejanoPixelX)+g_dbTheta[2][0]);
			plejanoY = (int)((g_dbTheta[0][1]*plejanoPixelY)+(g_dbTheta[1][1]*plejanoPixelX)+g_dbTheta[2][1]);
			//Calculamos el angulo en radianes
			flOrIniKoa=atan2((float)(plejanoY-nPosIniYKoa),(float)(plejanoX-nPosIniXKoa));
			return true;
		}
		else
			return false;
	}
	else
		return false;
}

/*Esta es la segunda parte de recepcin. Es decir, cuando hemos indicado que se haga el trabajo coordinado
de ambos robots, stos han llegado a su posicin final y en la parte del cliente hemos recibido los men sajes
de que ambos robots estn en su posicin entonces se ejecuta esta funcin. Bsicamente lo que hace es decirle 
al Create que empuje la pelota y que cuando acaba indica a ambos robots que vayan a su posicin inicial de
partida*/
void CPlanificacion_TrayDlg::RecogerPelota()
{
	int iResult=0, nCodigo = 0;
	unsigned char recibidos[1];
	CString szAux;	
	DWORD   dwBytesReturned=0;
    DWORD   status;
    DWORD   dwBufferLen;	
	dwBufferLen = 0;
	ULONG block = 0;
	
	WSAAsyncSelect(m_ConnectSocket, this->m_hWnd, 0, 0);
	WSAAsyncSelect(m_ConnectSKoala, this->m_hWnd, 0, 0);

	status = WSAIoctl(m_ConnectSocket, FIONBIO, &block, sizeof(ULONG),&dwBufferLen, sizeof(dwBufferLen),&dwBytesReturned, NULL, NULL);
    if (SOCKET_ERROR == status)
    {
        DWORD dwErr = WSAGetLastError();
        AfxMessageBox(_T("WSAIoctl(FIONBIO)-query: %d\n"),dwErr);
		return;
    }
	
	status = WSAIoctl(m_ConnectSKoala, FIONBIO, &block, sizeof(ULONG),&dwBufferLen, sizeof(dwBufferLen),&dwBytesReturned, NULL, NULL);
    if (SOCKET_ERROR == status)
    {
        DWORD dwErr = WSAGetLastError();
        AfxMessageBox(_T("WSAIoctl(FIONBIO)-query: %d\n"),dwErr);
		return;
    }

	//Envio al CREATE para que sepa que tiene que moverse 10 cm y meter la bola
	recibidos[0] = 1;
    iResult = send( m_ConnectSocket, (char *)recibidos, 1, 0 );
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.254\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bytes enviados: %d de posicion inicial y final precalculados\r\nEsperando que el CREATE llegue a la posicion final...\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	// Recibo 1 byte para saber que el CREATE ha empujado la pelota
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult == 1)
		szAux.Format(_T("Respuesta aceptada de 192.168.253.254. Enviando informacion al CREATE...\r\n"), iResult);
	else {
        szAux.Format(_T("Fallo de recepcin en 192.168.253.254\r\n") );
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	//Envio para indicar al KOALA que vaya a la posicion inicial
	Sleep(5000); //para que no choque con el create
	recibidos[0] = 0;
    iResult = send( m_ConnectSKoala, (char *)recibidos, 1, 0 );
	if (iResult != 1) {
        m_sResumen += _T("No se han podido enviar todos los bytes al 192.168.253.252\r\n");
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
	szAux.Format(_T("Bye enviado al KOALA. Esperando que termine la ejecucin del CREATE\r\n"), iResult);
	m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	// Recibo 1 byte para saber que el CREATE ha terminado
    iResult = recv(m_ConnectSocket, (char*)recibidos, 1, 0);
    if ( iResult == 1)
		szAux.Format(_T("Respuesta aceptada de 192.168.253.254. Esperando a que el KOALA llegue a la posicion inicial\r\n"), iResult);
	else {
        szAux.Format(_T("Fallo de recepcin en 192.168.253.254\r\n") );
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();

	// Recibo 1 byte para saber que el KOALA ha llegado a la posicion final
    iResult = recv(m_ConnectSKoala, (char*)recibidos, 1, 0);
    if ( iResult == 1)
		szAux.Format(_T("Respuesta aceptada de 192.168.253.252. Ejecucin finalizada correctamente\r\n"), iResult);
	else {
        szAux.Format(_T("Fallo de recepcin en 192.168.253.252\r\n") );
		m_ButtonComenzar.EnableWindow(true);
		m_ButtonEmpezarTray.EnableWindow(true);
		m_bComenzar = true;
		UpdateData(false);
		DoEvents();
        closesocket(m_ConnectSocket);
		closesocket(m_ConnectSKoala);
        WSACleanup();
		EndWaitCursor();
        return;
	}
    m_sResumen += szAux;
	UpdateData(false);
	DoEvents();
	//Vamos a recibir mensajes de forma asincrona ya que no se cuando finaliza el proceso	
	cvDestroyWindow("WebCam");
	cvDestroyWindow("Create");	
	cvDestroyWindow("Pos. Final");
	cvDestroyWindow("Koala");	
	cvReleaseCapture(&m_Capture);
    closesocket(m_ConnectSocket);
	closesocket(m_ConnectSKoala);
    WSACleanup();
	EndWaitCursor();
}