// Planificacion_TrayDlg.h: archivo de encabezado
//
#include <highgui.h>
#include <cv.h>

#pragma once

#ifdef _MSC_VER
    #pragma comment(lib, "libdetecta.lib")
	#pragma comment(lib, "mclcommain.lib")
	#pragma comment(lib, "mclmcr.lib")
	#pragma comment(lib, "mclmcrrt.lib")
	#pragma comment(lib, "libmat.lib")
	#pragma comment(lib, "libmex.lib")
	#pragma comment(lib, "libmwblas.lib")
	#pragma comment(lib, "libmwlapack.lib")
	#pragma comment(lib, "libmwmathutil.lib")
	#pragma comment(lib, "libmwservices.lib")
	#pragma comment(lib, "libmx.lib")
	#pragma comment(lib, "libut.lib")
#endif

//#include "afxwin.h"

// Cuadro de dilogo de CPlanificacion_TrayDlg
class CPlanificacion_TrayDlg : public CDialog
{
// Construccin
public:
	CPlanificacion_TrayDlg(CWnd* pParent = NULL);	// Constructor estndar

// Datos del cuadro de dilogo
	enum { IDD = IDD_PLANIFICACION_TRAY_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// Compatibilidad con DDX/DDV


// Implementacin
protected:
	HICON m_hIcon;

	// Funciones de asignacin de mensajes generadas
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
	/**Indica propiedades del edit del punto descentralizado E*/
	CEdit m_EditE;
	/**Variable miembro para capturar imagenes de la cmara cenital*/
	CvCapture* m_Capture;
	/**Variable miembro que contiene el valor del punto descentralizado E*/
	int m_nE;
	/**Indica propiedades del edit del Periodo*/
	CEdit m_EditPeriodo;
	/**Variable miembro que contiene el valor del periodo*/
	float m_flPeriodo;
	/**Indica propiedades del edit de la ganancia KPX*/
	CEdit m_EditKPX;
	/**Variable miembro que contiene el valor de la ganancia KPX*/
	float m_flKPX;
	/**Indica propiedades del edit de la ganancia KPY*/
	CEdit m_EditKPY;
	/**Variable miembro que contiene el valor de la ganancia KPY*/
	float m_flKPY;
	/**Indica propiedades del edit de la ganancia KVX*/
	CEdit m_EditKVX;
	/**Variable miembro que contiene el valor de la ganancia KVX*/
	float m_flKVX;
	/**Indica propiedades del edit de la ganancia KVY*/
	CEdit m_EditKVY;
	/**Variable miembro que contiene el valor de la ganancia KVY*/
	float m_flKVY;
	/**Indica propiedades del edit del lado 1 del rectngulo*/
	CEdit m_EditL1;
	/**Variable miembro que contiene el valor del lado 1 del rectngulo*/
	int m_nL1;
	/**Indica propiedades del edit del lado 2 del rectngulo*/
	CEdit m_EditL2;
	/**Variable miembro que contiene el valor del lado 2 del rectngulo*/
	int m_nL2;
	/**Indica propiedades del edit del radio de la circunferencia*/
	CEdit m_EditRadio;
	/**Variable miembro que contiene el valor del radio de la circunferencia*/
	int m_nRadio;
	/**Indica propiedades del edit de la frecuencia del crculo*/
	CEdit m_EditFrecuencia;
	/**Indica propiedades del edit asociado con la ganancia KRHO*/
	CEdit m_EditKRHO;
	/**Indica propiedades del edit asociado con la ganancia KALFA*/
	CEdit m_EditKALFA;
	/**Indica propiedades del edit asociado con la ganancia KBETA*/
	CEdit m_EditKBETA;
	/**Indica propiedades del edit asociado con la ganancia KP*/
	CEdit m_EditKP;
	/**Variable miembro que contiene el valor de la frecuencia del crculo*/
	float m_flFrecuencia;
	/**Indica propiedades del edit asociado con la velocidad de referencia*/
	CEdit m_EditVelocidad;
	/**Indica propiedades del edit asociado con la posixin X inicial del robot*/
	CEdit m_EditPosX;
	/**Indica propiedades del edit asociado con la posixin Y inicial del robot*/
	CEdit m_EditPosY;
	/**Variable miembro que contiene el valor de la posicin X inicial del robot*/
	int m_nPosX;
	/**Variable miembro que contiene el valor de la posicin Y inicial del robot*/
	int m_nPosY;
	/**Variable miembro que contiene el valor de la velocidad de referencia*/
	int m_nVelocidad;
	/**variable asociada con la opcin de seguimiento de trayectoria por punto descentralizado*/
	CButton m_ButtonTrayectoria;
	/**Variable asociada con la opcin de seguimiento de camino por persecucin pura*/
	CButton m_ButtonCamino;
	/**variable asociada con la opcin "rectangulo" para realizar un seguimiento con forma de rectngulo*/
	CButton m_ButtonRectangulo;
	/**variable asociada con la opcin "circunferencia" para realizar un seguimiento con forma de circunferencia*/
	CButton m_ButtonCircun;
	/**variable asociada con la opcin "pos. final" para realizar un seguimiento para llegar a un punto destino*/
	CButton m_ButtonPosicion;
	/**variable asociada con la opcin "trayectoria" para realizar un trayectoria con MATLAB con evitacin de obstculos*/
	CButton m_ButtonTray;
	/**variable asociada con la opcin "recoger pelota" para realizar la tarea conjunta de ambos robots*/
	CButton m_ButtonSeguimiento;
	/**Variable asociada al botn COMENZAR para realizar un rectangulo / circulo / posicin final*/
	CButton m_ButtonComenzar;
	/**Variable asociada al botn COMENZAR para seguir la trayectoria con evitacin de obstculos*/
	CButton m_ButtonEmpezarTray;
	/**indica propiedades del edit asociado con el valor del RASTER*/
	CEdit m_EditRaster;
	/**Indica si se quiere ver grficamente el resultado de la trayectoria generada por MATLAB*/
	CButton m_CheckTray;
	int m_nTray;
	/**Variable miembro asociada con el valor del raster*/
	int m_nRaster;
	int m_nSeguimiento;
	/**Variable que indica si se ha ejecutado alguna opcin. Es decir, mientras se est ejecutando algn algoritmo
	en el Create esta variavle vale cierto. esto es para no dejar ejecutar ms veces ninguna opcin, excepto
	la de parada de emergencia*/
	bool m_bComenzar;
	/**Variable que contiene la informacion de todo el comportamiento*/
	unsigned char datos[51];	
	/**Conexin socker para procesamiento del algoritmo con el create*/
	SOCKET m_ConnectSocket;
	/**Conexin socker para envo de parada de emergencia del create*/
	SOCKET m_SocketParada;
	/**Conexin socker para procesamiento del algoritmo con el koala*/
	SOCKET m_ConnectSKoala;
	/**Variable miembro que contiene la informacin actual del edit para indicar al usuario lo que sucede actualmente*/
	CString m_sResumen;
	/**Variable miembro para indicar la posicin X destino, cuando se selcciona esta opcin*/
	int m_nFinalX;
	/**Variable miembro para indicar la posicin Y destino, cuando se selcciona esta opcin*/
	int m_nFinalY;
	/**Variable miembro para indicar manualmente la orientacin inicial del robot*/
	int m_nGrados;
	/**Variable miebro asociada con el valor de la ganancia KRHO*/
	float m_flKRHO;
	/**Variable miebro asociada con el valor de la ganancia KALFA*/
	float m_flKALFA;
	/**Variable miebro asociada con el valor de la ganancia KBETA*/
	float m_flKBETA;
	/**Variable miebro asociada con el valor de la ganancia KP*/
	float m_flKP;
	/**Funcin que habilita o deshabilita cada uno de los edit en funcin de las opciones selccionadas. Esta
	funcin  tiene que ser llamada cada vez que cambia el valor de alguna seleccin, para que habilite o no
	cada uno de los edit*/
	void ActualizarCuadros();
	/**Funcin que rellena la estructura de datos que tiene que enviar al Create con todos los valores referentes
	a la trayectoria a generar, as como las diferentes ganancias de cada uno de los algoritmos de control*/
	void RellenaDatos(int nTamReferencia,float flOrientacion);
	/**Funcin que actualiza la opcin seleccionada referente al algoritmo de control*/
	afx_msg void OnBnClickedRadioTrayectoria();
	/**Funcin que actualiza la opcin seleccionada referente al algoritmo de control*/
	afx_msg void OnBnClickedRadioCamino();
	/**Funcin que cierra la ejecucin del programa*/
	afx_msg void OnBnClickedCancel();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditE();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKpx();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKpy();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKvx();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKvy();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditPeriodo();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditL1();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditRadio();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditVelocidad();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditL2();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditFrecuencia();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKRHO();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKALFA();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKBETA();
	/**Funcin utilizada para controlar la longitud del nmero utilizado, tanto en la parte entera como en la decimal*/
	afx_msg void OnEnKillfocusEditKP();
	/**Funcin asociada con la opcin de generar un rectngulo como trayectoria de referencia*/
	afx_msg void OnBnClickedRadioRectangulo();
	/**Funcin asociada con la opcin de generar una circunferencia como trayectoria de referencia*/
	afx_msg void OnBnClickedRadioCircunferencia();
	/**Funcin que se ejecuta cuando pulsamos sobre el botn COMENZAR asociado al tipo de referencia. Cuando el
	botn se pulsa se ejecuta esta funcin y lo que hace es establecer la comunicacin con el create para que 
	realice la trayectoria indicada. Cuando el robot termina de realizar la trayectoria se lo informa a este PC
	y automticamente copia el fichero de resultados del sistema embebido al pc, para abrir el MATLAB y as
	estudiar los datos obtenidos*/
	afx_msg void OnBnClickedButtonempezar();
	/**Esta funcin se ejecuta para refrescar todo el formulario. Esto es debido al reloj que se muestra, que produce
	inconsistencias en los mensajes del formulario*/
	void DoEvents();
	/**Funcin que se ejecuta cuando elegimos llegar a una posicin final de forma manual, no por camara*/
	afx_msg void OnBnClickedRadioPosicion();
	/**Funcin que se ejecuta cuando elegimos seguir una trayectoria generada con MATLAB con evitacin de obstculos*/
	afx_msg void OnBnClickedRadioTray();
	/**Esta funcin se lanza automticamente por eventos de notificacin de mensajes cuando hemos convertido
	el socket en asncrono. CUando existe informacin en el buffer del socket asociado al robot Create entonces
	salta esta funcin. Bsicamente lo que se hace es leer del buffer y extraer la informacin, que ser para
	indicarnos que el Create ya est preparado para empujar la pelota, cuando as se lo indique este PC*/
	LRESULT OnRecepcion_CREATE(WPARAM wParam, LPARAM lParam);
	/**Esta funcin se lanza automticamente por eventos de notificacin de mensajes cuando hemos convertido
	el socket en asncrono. Cuando existe informacin en el buffer del socket asociado al robot Koala entonces
	salta esta funcin. Bsicamente lo que se hace es leer del buffer y extraer la informacin, que ser para
	indicarnos que el Koala ya est en su posicin para recoger la pelota*/
	LRESULT OnRecepcion_KOALA(WPARAM wParam, LPARAM lParam);
	/**Esta funcin activa la parada de emergencia del Create. Simplemente lo que hace es enviar un comando especial
	al robot para indicarle que tiene que proceder a una parada completa del algoritmo actual de ejecucin*/
	afx_msg void OnBnClickedButtonparada();
	/**Esta funcin se conecta con el Create para indicarle que haga el algoritmo de control seleccionado con 
	el objetivo de seguir la trayectoria generada por MATLAB con evitacin de obstculos*/ 
	afx_msg void OnBnClickedButtonempezartray();
	/**esta funcin es la que activa el trabajo coordinado por ambos robots. Bsicamente lo que hace con OPENCV
	es obtener la imagen de la cmara, extrae posiciones inciales y finales e indica a ambos robots que vayan s
	sus posiciones para recoger la pelota. Finalmente hacemos el socket asncrono para seguir con la programacion
	cuando recibamos los mensajes de ambos robots*/
	afx_msg void OnBnClickedButtonsigue();
	/**Opcin relacionada con el radio de seguimiento de trayectoria*/
	afx_msg void OnBnClickedRadioSeguimiento();
	/**Esta es la segunda parte de recepcin. Es decir, cuando hemos indicado que se haga el trabajo coordinado
	de ambos robots, stos han llegado a su posicin final y en la parte del cliente hemos recibido los men sajes
	de que ambos robots estn en su posicin entonces se ejecuta esta funcin. Bsicamente lo que hace es decirle 
	al Create que empuje la pelota y que cuando acaba indica a ambos robots que vayan a su posicin inicial de
	partida*/
	afx_msg void RecogerPelota();
};

/**esta funcin es la que calcula las posiciones y orientaciones iniciales de los dos robots y la posicin
final de donde tiene que llegar. Para ello hace uso de OPENCV y obtiene la imagen, realiza varias segmentaciones
en funcin de los tres componentes que se quieren calcular, los procesa y envia estos datos por los
parmetros de referencia*/
bool CalculaImagen(IplImage* imgOriginal,int &nPosIniXCrea,int &nPosIniYCrea,float &flOrIniCrea,int &nPosIniXKoa,int &nPosIniYKoa,float &flOrIniKoa,int &nPosFinX,int &nPosFinY);