#include "Control_Robot.h"
#include "IRCR.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/time.h>
#include "IRCR.h"

#include <dlfcn.h>
#include <sys/time.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

#define PUERTO 3490
#define BACKLOG 10
#define VEL_SUPERIOR 500
#define VEL_INFERIOR -500
/******FUNCIONES DE GENERACION DE TRAYECTORIAS *******/

void Generar_Rectangulo(int nLado_1,int nLado_2)
{
    //Calculamos el tamao
    //De momento nos olvidamos de los calculos en los angulos
    //Para hacer un lado es el tamao del lado entre la velocidad y periodo de muestreo
    int nIteraciones = 0;
    int nCuartaParte1 = 0, nCuartaParte2 = 0;
    float posX = 0, posY = 0, flIncremento = 0;
	int nTam1 = 0, nTam2 = 0;
    nTam1 = nLado_1 / (g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
	nTam2 = nLado_2 / (g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
    g_nTamano = (2*nTam1) + (2*nTam2);
    flIncremento = g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad;
	nCuartaParte1 = nTam1 / 4;
	nCuartaParte2 = nTam2 / 4;
    g_nPosicion_Ref_X  = (int *)malloc(g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc(g_nTamano * sizeof(int));

    //Lado 1
    while (nIteraciones < nTam1)
    {
        posX += flIncremento;
        g_nPosicion_Ref_X[nIteraciones] = posX;
        g_nPosicion_Ref_Y[nIteraciones] = posY;
        g_nVelocidad_Ref_X[nIteraciones] = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nIteraciones] = 0;
		if ( (nIteraciones < nCuartaParte1) || ( (3*nCuartaParte1) <= nIteraciones ) )
			g_nVelocidad_Ref_X[nIteraciones] = (int)(g_DatosReferencia.nVelocidad/4);

        nIteraciones++;
    }
    //Lado 2
    while (nIteraciones < (nTam1+nTam2) )
    {
        posY += flIncremento;
        g_nPosicion_Ref_X[nIteraciones] = posX;
        g_nPosicion_Ref_Y[nIteraciones] = posY;
        g_nVelocidad_Ref_X[nIteraciones] = 0;
        g_nVelocidad_Ref_Y[nIteraciones] = g_DatosReferencia.nVelocidad;
		if ( (nIteraciones <= (nTam1+nCuartaParte2) ) ||
			( (3*nCuartaParte2)+nTam1 <= nIteraciones))
			g_nVelocidad_Ref_Y[nIteraciones] = (int)(g_DatosReferencia.nVelocidad/4);

        nIteraciones++;
    }
    //Lado 3
    while (nIteraciones < ((2*nTam1)+nTam2) )
    {
        posX -= flIncremento;
        g_nPosicion_Ref_X[nIteraciones] = posX;
        g_nPosicion_Ref_Y[nIteraciones] = posY;
        g_nVelocidad_Ref_X[nIteraciones] = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nIteraciones] = 0;
		if ( ( nIteraciones <= nTam1+nTam2+nCuartaParte1) ||
		   ( ( nTam1+nTam2+(3*nCuartaParte1) <= nIteraciones) ))
			g_nVelocidad_Ref_X[nIteraciones] = (int)(g_DatosReferencia.nVelocidad/4);

        nIteraciones++;
    }
    //Lado 4
    while (nIteraciones < ((2*nTam1)+(2*nTam2)) )
    {
        posY -= flIncremento;
        g_nPosicion_Ref_X[nIteraciones] = posX;
        g_nPosicion_Ref_Y[nIteraciones] = posY;
        g_nVelocidad_Ref_X[nIteraciones] = 0;
        g_nVelocidad_Ref_Y[nIteraciones] = g_DatosReferencia.nVelocidad;
        if ( (nIteraciones <= 2*nTam1+nTam2+nCuartaParte2) ||
			( (2*nTam1+nTam2+(3*nCuartaParte2) <= nIteraciones) ))
			g_nVelocidad_Ref_Y[nIteraciones] = (int)(g_DatosReferencia.nVelocidad/4);

        nIteraciones++;
    }
}

void Generar_Circulo(int nRadio,float fFrecuencia)
{
    int nIteracion = 0;
    g_nTamano = 1 / (fFrecuencia * g_DatosReferencia.fTS);
    g_nPosicion_Ref_X  = (int *)malloc(g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc(g_nTamano * sizeof(int));
    for (nIteracion = 0;nIteracion < g_nTamano;nIteracion++)
    {
        g_nPosicion_Ref_X[nIteracion] = nRadio * cos(2 * M_PI * fFrecuencia * nIteracion * g_DatosReferencia.fTS);
        g_nPosicion_Ref_Y[nIteracion] = nRadio * sin(2 * M_PI * fFrecuencia * nIteracion * g_DatosReferencia.fTS);
        g_nVelocidad_Ref_X[nIteracion]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nIteracion]  = g_DatosReferencia.nVelocidad;
    }
}

void Generar_Trayectoria()
{
    int nDistancia = 0, nIteraciones = 0, nCont = 0, nTotalI = 0, nCont2 = 0;
    float flModulo = 0;
    float flX = 0, flY = 0, flMx, flMy;

    //En este caso el modulo es fijo es siempre 360 mm que es lo que ocupa el robot. Realmente es el raster
    //Hay que pasarlo de pixeles a mm. es decir si 70 pixeles son 360 mm entonces 1 pixel es 5
    flModulo = g_DatosReferencia.nRaster*5;
    nDistancia = (int)(g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
    nIteraciones = (int)(flModulo / nDistancia);
    nTotalI = g_DatosReferencia.nTamReferencias; //Total de referencias que me dan

    g_nTamano = (nIteraciones*(nTotalI-1)+1);
    //reservamos el total de posiciones
    g_nPosicion_Ref_X  = (int *)malloc( g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc( g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc( g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc( g_nTamano * sizeof(int));

    for (nCont2 = 0;nCont2 < nTotalI-1;nCont2++)
    {
        flX = (float)g_nRefX[nCont2];
        flY = (float)g_nRefY[nCont2];
        flMx = (g_nRefX[nCont2+1] - flX) / flModulo;
        flMy = (g_nRefY[nCont2+1] - flY) / flModulo;
        g_nPosicion_Ref_X[nCont2*nIteraciones]   = (int)flX;
        g_nPosicion_Ref_Y[nCont2*nIteraciones]   = (int)flY;
        g_nVelocidad_Ref_X[nCont2*nIteraciones]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont2*nIteraciones]  = g_DatosReferencia.nVelocidad;
        for (nCont = (nCont2*nIteraciones)+1;nCont < ( (nCont2+1)*nIteraciones);nCont++)
        {
            flX = (float)(flX + (flMx*nDistancia));
            flY = (float)(flY + (flMy*nDistancia));
            g_nPosicion_Ref_X[nCont] = (int)flX;
            g_nPosicion_Ref_Y[nCont] = (int)flY;
            g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
            g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
        }
    }
    g_nPosicion_Ref_X[nCont]   = g_nRefX[nCont2];
    g_nPosicion_Ref_Y[nCont]   = g_nRefY[nCont2];
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    //Ya podemos liberar el vector intermedio de posiciones
    free(g_nRefX);
    free(g_nRefY);
}

void Generar_Trayectoria_Dos_Puntos(int nPosFinalX,int nPosFinalY)
{
    int nDistancia = 0, nIteraciones = 0, nCont = 0;
    float flModulo = 0;
    float flX = 0, flY = 0, flMx, flMy;
    nDistancia = (int)(g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
    flModulo = sqrt(pow((nPosFinalX - g_DatosReferencia.nPosX),2) + pow((nPosFinalY - g_DatosReferencia.nPosY),2) );
    nIteraciones = (int)(flModulo / nDistancia);
    g_nTamano = nIteraciones + 1;
    g_nPosicion_Ref_X  = (int *)malloc(g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc(g_nTamano * sizeof(int));
    flX = (float)g_DatosReferencia.nPosX;
    flY = (float)g_DatosReferencia.nPosY;
    flMx = (nPosFinalX - g_DatosReferencia.nPosX) / flModulo;
    flMy = (nPosFinalY - g_DatosReferencia.nPosY) / flModulo;
    g_nPosicion_Ref_X[0]   = (int)flX;
    g_nPosicion_Ref_Y[0]   = (int)flY;
    g_nVelocidad_Ref_X[0]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[0]  = g_DatosReferencia.nVelocidad;
    for (nCont = 1;nCont < nIteraciones;nCont++)
    {
        flX = (float)(flX + (flMx*nDistancia));
        flY = (float)(flY + (flMy*nDistancia));
        g_nPosicion_Ref_X[nCont] = (int)flX;
        g_nPosicion_Ref_Y[nCont] = (int)flY;
        g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    }
    g_nPosicion_Ref_X[nCont]   = nPosFinalX;
    g_nPosicion_Ref_Y[nCont]   = nPosFinalY;
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
}

/**Cuando se ejecuta la tarea coordinada para ir a por la pelota esta funcion genera la trayectoria
para hacer la mitad de un cuadrado*/
void Generar_Trayectoria_tres_PuntosIrPelota(int nPosInicialX,int nPosInicialY,int nPosFinalX,int nPosFinalY)
{
    int nDistancia = 0, nIteraciones1 = 0, nIteraciones2 = 0, nCont = 0;
    float flModulo1 = 0, flModulo2 = 0;
    float flX = 0, flY = 0, flMx, flMy;
    nDistancia = (int)(g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
    //PASO 1. Desde el punto inicial al punto inertmedio
    flModulo1 = sqrt(pow((nPosInicialX - nPosInicialX),2) + pow((nPosFinalY - nPosInicialY),2) );
    flModulo2 = sqrt(pow((nPosFinalX - nPosInicialX),2) + pow((nPosFinalY - nPosFinalY),2) );
    nIteraciones1 = (int)( flModulo1 / nDistancia);
    nIteraciones2 = (int)( flModulo2 / nDistancia);
    g_nTamano = nIteraciones1 + nIteraciones2 + 1;
    g_nPosicion_Ref_X  = (int *)malloc(g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc(g_nTamano * sizeof(int));

    flX = (float)nPosInicialX;
    flY = (float)nPosInicialY;
    flMx = 0;
    flMy = (nPosFinalY - nPosInicialY) / flModulo1;

    g_nPosicion_Ref_X[0]   = (int)flX;
    g_nPosicion_Ref_Y[0]   = (int)flY;
    g_nVelocidad_Ref_X[0]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[0]  = g_DatosReferencia.nVelocidad;
    for (nCont = 1;nCont < nIteraciones1;nCont++)
    {
        flY = (float)(flY + (flMy*nDistancia));
        g_nPosicion_Ref_X[nCont] = (int)flX;
        g_nPosicion_Ref_Y[nCont] = (int)flY;
        g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    }
    g_nPosicion_Ref_X[nCont]   = (int)flX;
    g_nPosicion_Ref_Y[nCont]   = nPosFinalY;
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;

    //PASO 2. Desde el punto intermedio hasta el punto final
    flX = (float)nPosInicialX;
    flY = (float)nPosFinalY;
    flMx = (nPosFinalX - nPosInicialX) / flModulo2;
    flMy = 0;
    for (;nCont < (nIteraciones1+nIteraciones2);nCont++)
    {
        flX = (float)(flX + (flMx*nDistancia));
        g_nPosicion_Ref_X[nCont] = (int)flX;
        g_nPosicion_Ref_Y[nCont] = (int)flY;
        g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    }
    g_nPosicion_Ref_X[nCont]   = nPosFinalX;
    g_nPosicion_Ref_Y[nCont]   = nPosFinalY;
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
}

/**Cuando se ejecuta la tarea coordinada para ir a por la pelota esta funcion genera la trayectoria
para hacer la mitad de un cuadrado pero desde la pelota a la posicion inicial*/
void Generar_Trayectoria_tres_PuntosVolver(int nPosInicialX,int nPosInicialY,int nPosFinalX,int nPosFinalY)
{
    int nDistancia = 0, nIteraciones1 = 0, nIteraciones2 = 0, nCont = 0;
    float flModulo1 = 0, flModulo2 = 0;
    float flX = 0, flY = 0, flMx, flMy;
    nDistancia = (int)(g_DatosReferencia.fTS * g_DatosReferencia.nVelocidad);
    //PASO 1. Desde el punto inicial al punto inertmedio
    flModulo1 = sqrt(pow((nPosFinalX - nPosInicialX),2) + pow((nPosInicialY - nPosInicialY),2) );
    flModulo2 = sqrt(pow((nPosFinalX - nPosFinalX),2) + pow((nPosFinalY - nPosInicialY),2) );
    nIteraciones1 = (int)( flModulo1 / nDistancia);
    nIteraciones2 = (int)( flModulo2 / nDistancia);
    g_nTamano = nIteraciones1 + nIteraciones2 + 1;
    g_nPosicion_Ref_X  = (int *)malloc(g_nTamano * sizeof(int));
    g_nPosicion_Ref_Y  = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_X = (int *)malloc(g_nTamano * sizeof(int));
    g_nVelocidad_Ref_Y = (int *)malloc(g_nTamano * sizeof(int));

    flX = (float)nPosInicialX;
    flY = (float)nPosInicialY;
    flMx = (nPosFinalX - nPosInicialX) / flModulo1;
    flMy = 0;

    g_nPosicion_Ref_X[0]   = (int)flX;
    g_nPosicion_Ref_Y[0]   = (int)flY;
    g_nVelocidad_Ref_X[0]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[0]  = g_DatosReferencia.nVelocidad;
    for (nCont = 1;nCont < nIteraciones1;nCont++)
    {
        flX = (float)(flX + (flMx*nDistancia));
        g_nPosicion_Ref_X[nCont] = (int)flX;
        g_nPosicion_Ref_Y[nCont] = (int)flY;
        g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    }
    g_nPosicion_Ref_X[nCont]   = nPosFinalX;
    g_nPosicion_Ref_Y[nCont]   = (int)flY;
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;

    //PASO 2. Desde el punto intermedio hasta el punto final
    flX = (float)nPosFinalX;
    flY = (float)nPosInicialY;
    flMx = 0;
    flMy = (nPosFinalY - nPosInicialY) / flModulo2;
    for (;nCont < (nIteraciones1+nIteraciones2);nCont++)
    {
        flY = (float)(flY + (flMy*nDistancia));
        g_nPosicion_Ref_X[nCont] = (int)flX;
        g_nPosicion_Ref_Y[nCont] = (int)flY;
        g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
        g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
    }
    g_nPosicion_Ref_X[nCont]   = nPosFinalX;
    g_nPosicion_Ref_Y[nCont]   = nPosFinalY;
    g_nVelocidad_Ref_X[nCont]  = g_DatosReferencia.nVelocidad;
    g_nVelocidad_Ref_Y[nCont]  = g_DatosReferencia.nVelocidad;
}

/***** ALGORITMOS DE CONTROL ****/

/**Algoritmo de control de trayectoria por punto descentralizado*/
int Control_Trayectoria(int conexion)
{
    int nDiferencia=0;
    struct timeval tvInicio, tvFin;
    struct timezone tz;
	// TODO: Agregue aqu su cdigo de controlador de notificacin de control
	float flXm = 0, flYm = 0, flTheta = 0;
	short int nPosicion = 0, nAngulo = 0;
    float flVel_Xp = 0, flVel_Yp = 0;
    int nTiempo = 0;
    int nVel_Izq = 0, nVel_Der = 0;
    int nIteraciones = 0;
	FILE *fichero;
	int iResult=0;
	g_nParada = 0;
    //Inicializo los encoders
    if (Distancia(&nPosicion) == 0)
        return 1;
    if (Angulo(&nAngulo) == 0)
        return 1;
    //Esto solo vale cuando no es una trayectoria. Sino es el principio de la trayectoria
    if (g_DatosReferencia.nTipoRef != 3)
    {
        flXm = g_DatosReferencia.nPosX;
        flYm = g_DatosReferencia.nPosY;
        if (g_DatosReferencia.nTipoRef == 4)
          flTheta = g_flOrientaInicial;
        else
        {
            nAngulo = (int)g_DatosReferencia.flOrientacion;
            flTheta = (nAngulo * M_PI) /180;
        }
    }
    else
    {
        flXm = g_nPosicion_Ref_X[0];
        flYm = g_nPosicion_Ref_Y[0];
        flTheta = g_DatosReferencia.flOrientacion; //En este caso ya viene en radianes
    }
    printf("PosIniX=%f PosIniY=%f PosFinX=%d PosFinY=%d\n",flXm,flYm,g_nPosFinalX,g_nPosFinalY);
	fichero = fopen("datos.txt","w+");
    for (nIteraciones = 0; nIteraciones < g_nTamano; nIteraciones++)
    {
        //Empieza el tiempo
        gettimeofday( &tvInicio, &tz );
        //Calculamos donde deberia estar el robot
		if (Distancia(&nPosicion) == 0)
            return 1;
		flXm = flXm + (nPosicion * cos(flTheta) );
        flYm = flYm + (nPosicion * sin(flTheta) );
        flTheta = flTheta + ( (float)((float)(nVel_Der-nVel_Izq) / (float)(2*B)) * g_DatosReferencia.fTS);
        printf("PosX=%f PosY=%f Angulo=%f RefX=%d RefY=%d\n",flXm,flYm,flTheta,g_nPosicion_Ref_X[nIteraciones],g_nPosicion_Ref_Y[nIteraciones]);
		fprintf(fichero,"%f\t%f\t%d\t%d\n",flXm,flYm,g_nPosicion_Ref_X[nIteraciones],g_nPosicion_Ref_Y[nIteraciones]);
		//Calculamos accion de control
        flVel_Xp = (float)((float)(g_DatosReferencia.fKVX * g_nVelocidad_Ref_X[nIteraciones]) +
                    (float)(g_DatosReferencia.fKPX * (g_nPosicion_Ref_X[nIteraciones] - flXm - (g_DatosReferencia.nPuntoE * cos(flTheta)) ) ));

        flVel_Yp = (float)((float)(g_DatosReferencia.fKVY * g_nVelocidad_Ref_Y[nIteraciones]) +
                    (float)(g_DatosReferencia.fKPY * (g_nPosicion_Ref_Y[nIteraciones] - flYm - (g_DatosReferencia.nPuntoE * sin(flTheta)) ) )) ;
        //Lo convertimos a velocidades
        nVel_Izq =  floor((float)(((g_DatosReferencia.nPuntoE*cos(flTheta)) + (B*sin(flTheta) )) * flVel_Xp) +
                    ( ((g_DatosReferencia.nPuntoE*sin(flTheta)) - (B*cos(flTheta) )) * flVel_Yp) / g_DatosReferencia.nPuntoE);
        nVel_Der =  floor((float)(((g_DatosReferencia.nPuntoE*cos(flTheta)) - (B*sin(flTheta) )) * flVel_Xp) +
                    ( ((g_DatosReferencia.nPuntoE*sin(flTheta)) + (B*cos(flTheta) )) * flVel_Yp) / g_DatosReferencia.nPuntoE);
        //Limitamos las velocidades
        if (nVel_Izq > VEL_SUPERIOR)
          nVel_Izq = VEL_SUPERIOR;
        if (nVel_Izq < VEL_INFERIOR)
          nVel_Izq = VEL_INFERIOR;
        if (nVel_Der > VEL_SUPERIOR)
          nVel_Der = VEL_SUPERIOR;
        if (nVel_Der < VEL_INFERIOR)
          nVel_Der = VEL_INFERIOR;

        //Mandamos las velocidades
		if (Velocidad_Independiente(nVel_Izq,nVel_Der) == 0)
            return 1;
        //Si se ha activado la parada paramos el robot
        if (g_nParada == 1)
        {
            printf("He salido con codigo 1\n");
            g_nParada = 0;
            fclose(fichero);
            free(g_nPosicion_Ref_X);
            free(g_nPosicion_Ref_Y);
            free(g_nVelocidad_Ref_X);
            free(g_nVelocidad_Ref_Y);
            if (Velocidad_Independiente(0,0) == 0)
                return 1;
            return 2;
        }
        //Si se ha reactivado la llamada. paramos este hilo y lanzamos otro hilo nuevo
        if (g_nParada == 3)
        {
            printf("He salido con codigo 3\n");
            g_nParada = 0;
            fclose(fichero);
            free(g_nPosicion_Ref_X);
            free(g_nPosicion_Ref_Y);
            free(g_nVelocidad_Ref_X);
            free(g_nVelocidad_Ref_Y);
            if (Velocidad_Independiente(0,0) == 0)
                return 1;
            return 3;
        }

        //Recibimos los primeros datos de inicio y fin calculados de la camara, que son 43 bytes
        /*iResult = recv(conexion, g_buffer,43,0);
        if (iResult == 43)
        {
            RellenaPosiciones();
            //Actualizamos los valores
            flTheta=g_flOrientaInicial;      //orientacion del robot movil
            flXm=(float)g_nPosInicialX;         //posicion X robot movil
            flYm=(float)g_nPosInicialY;         //posicion Y robot movil
            nIteraciones = 0;
            g_DatosReferencia.nPosX = g_nPosInicialX;
            g_DatosReferencia.nPosY = g_nPosInicialY;
            free(g_nPosicion_Ref_X);
            free(g_nPosicion_Ref_Y);
            free(g_nVelocidad_Ref_X);
            free(g_nVelocidad_Ref_Y);
            Generar_Trayectoria_Dos_Puntos(g_nPosFinalX,g_nPosFinalY);
        }*/

        //Aqui termina el tiempo. Esto es para restarlo al periodo a ver si funciona mejor
        gettimeofday( &tvFin, &tz );
        nDiferencia = (int)(tvFin.tv_sec*1000000 + tvFin.tv_usec) - (int)(tvInicio.tv_sec*1000000 + tvInicio.tv_usec);
        //Esperamos para la siguiente muestra
        nTiempo = (int)((g_DatosReferencia.fTS*1000000) - nDiferencia);
        if (nTiempo > 0)
            usleep(nTiempo);
    }
	fclose(fichero);
	//Paramos el robot
	if (Velocidad_Independiente(0,0) == 0)
        return 1;
    //Finalmente liberamos los vectores para que no falle memoria
    free(g_nPosicion_Ref_X);
    free(g_nPosicion_Ref_Y);
    free(g_nVelocidad_Ref_X);
    free(g_nVelocidad_Ref_Y);
    //para que se quede con el ultimo angulo
    if (g_DatosReferencia.nTipoRef == 4)
      flTheta = g_flOrientaInicial;
    return 0;//Todo ha ido bien
}

/****** SOCKETS *****/

int ConexionServidor()
{
	struct sockaddr_in my_addr;    /* Adresse */
    //Solo lo hacemos la priemra vez
	my_addr.sin_family = AF_INET;         /* host byte order */
	my_addr.sin_port = htons(PUERTO);     /* short, network byte order */
	my_addr.sin_addr.s_addr = inet_addr("192.168.253.254"); /* auto-remplissage avec mon IP */
	memset(&(my_addr.sin_zero),0, 8);        /* zero pour le reste de struct */

    if ((g_sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
    {
        perror("socket");
        exit(-1);
    }

    if (bind(g_sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr))== -1)
    {
        perror("bind");
        exit(-1);
    }
    if (listen(g_sockfd, BACKLOG) == -1)
    {
        perror("listen");
        exit(-1);
    }
    printf("CONEXIN SERVIDOR CREATE OK. ESPERANDO PETICIONES...\n");
    return 1;
}

int NuevaPeticion()
{
    int new_fd;
    int sin_size;
    struct sockaddr_in their_addr; /* Adresse du connect  */
	sin_size = sizeof(struct sockaddr_in);

	if ((new_fd = accept(g_sockfd, (struct sockaddr *)&their_addr,&sin_size)) == -1)
	{
		perror("accept");
		exit(-1);
	}
	printf("PETICIN ACEPTADA. identificador %d\n",new_fd);
	return new_fd;
}

void RellenaEstructura()
{
    unsigned char auxiliar[5];

    g_DatosReferencia.nTipoRef = g_buffer[0]; //datos[0] = Tipo de trayectoria: 0 --> Rectangulo; 1 --> Circulo; 2 --> Pos Final
                                                                                //3 --> Trayectoria
    if (g_DatosReferencia.nTipoRef == 0)
    {
        auxiliar[0] = g_buffer[1];
        auxiliar[1] = g_buffer[2];
        auxiliar[2] = g_buffer[3];
        auxiliar[3] = g_buffer[4];
        auxiliar[4] = '\0';
        g_DatosReferencia.nLado1 = atoi(auxiliar);
        auxiliar[0] = g_buffer[5];
        auxiliar[1] = g_buffer[6];
        auxiliar[2] = g_buffer[7];
        auxiliar[3] = g_buffer[8];
        auxiliar[4] = '\0';
        g_DatosReferencia.nLado2 = atoi(auxiliar);
        //Inicializamos lo demas a 0
        g_DatosReferencia.nRadio = 0;
        g_DatosReferencia.fFrecuencia = 0;
        g_DatosReferencia.nPosFinalX = 0;
        g_DatosReferencia.nPosFinalY = 0;
        g_DatosReferencia.nRaster = 0;
        g_DatosReferencia.nTamReferencias = 0;

    }
    else if (g_DatosReferencia.nTipoRef == 1)
    {
	/*Si es circulo:
		datos[1-4] = RADIO
		datos[5-8] = FRECUENCIA*/
        auxiliar[0] = g_buffer[1];
        auxiliar[1] = g_buffer[2];
        auxiliar[2] = g_buffer[3];
        auxiliar[3] = g_buffer[4];
        auxiliar[4] = '\0';
        g_DatosReferencia.nRadio = atoi(auxiliar);
        auxiliar[0] = g_buffer[5];
        auxiliar[1] = g_buffer[6];
        auxiliar[2] = g_buffer[7];
        auxiliar[3] = g_buffer[8];
        auxiliar[4] = '\0';
        g_DatosReferencia.fFrecuencia = atof(auxiliar);
        g_DatosReferencia.nLado1 = 0;
        g_DatosReferencia.nLado2 = 0;
        g_DatosReferencia.nPosFinalX = 0;
        g_DatosReferencia.nPosFinalY = 0;
        g_DatosReferencia.nRaster = 0;
        g_DatosReferencia.nTamReferencias = 0;
	}
    else if (g_DatosReferencia.nTipoRef == 2)
    {
        auxiliar[0] = g_buffer[1];
        auxiliar[1] = g_buffer[2];
        auxiliar[2] = g_buffer[3];
        auxiliar[3] = g_buffer[4];
        auxiliar[4] = '\0';
        g_DatosReferencia.nPosFinalX = atoi(auxiliar);
        auxiliar[0] = g_buffer[5];
        auxiliar[1] = g_buffer[6];
        auxiliar[2] = g_buffer[7];
        auxiliar[3] = g_buffer[8];
        auxiliar[4] = '\0';
        g_DatosReferencia.nPosFinalY = atoi(auxiliar);
        g_DatosReferencia.nRadio      = 0;
        g_DatosReferencia.fFrecuencia = 0;
        g_DatosReferencia.nLado1 = 0;
        g_DatosReferencia.nLado2 = 0;
        g_DatosReferencia.nRaster = 0;
        g_DatosReferencia.nTamReferencias = 0;
	}
	else if (g_DatosReferencia.nTipoRef == 3)
	{
        auxiliar[0] = g_buffer[1];
        auxiliar[1] = g_buffer[2];
        auxiliar[2] = g_buffer[3];
        auxiliar[3] = g_buffer[4];
        auxiliar[4] = '\0';
        g_DatosReferencia.nTamReferencias = atoi(auxiliar);
        auxiliar[0] = g_buffer[5];
        auxiliar[1] = g_buffer[6];
        auxiliar[2] = g_buffer[7];
        auxiliar[3] = g_buffer[8];
        auxiliar[4] = '\0';
        g_DatosReferencia.nRaster = atoi(auxiliar);
        g_DatosReferencia.nPosFinalX  = 0;
        g_DatosReferencia.nPosFinalY  = 0;
        g_DatosReferencia.nRadio      = 0;
        g_DatosReferencia.fFrecuencia = 0;
        g_DatosReferencia.nLado1      = 0;
        g_DatosReferencia.nLado2      = 0;
    }

	//velocidad de Referencia
	auxiliar[0] = g_buffer[9];
	auxiliar[1] = g_buffer[10];
	auxiliar[2] = g_buffer[11];
	auxiliar[3] = g_buffer[12];
	auxiliar[4] = '\0';
	g_DatosReferencia.nVelocidad = atoi(auxiliar);
    //Periodo de muestreo
   	auxiliar[0] = g_buffer[13];
	auxiliar[1] = g_buffer[14];
	auxiliar[2] = g_buffer[15];
	auxiliar[3] = g_buffer[16];
	auxiliar[4] = '\0';
	g_DatosReferencia.fTS = atof(auxiliar);
    //Posicion X
   	auxiliar[0] = g_buffer[17];
	auxiliar[1] = g_buffer[18];
	auxiliar[2] = g_buffer[19];
	auxiliar[3] = g_buffer[20];
	auxiliar[4] = '\0';
	g_DatosReferencia.nPosX = atoi(auxiliar);
    //Posicion Y
   	auxiliar[0] = g_buffer[21];
	auxiliar[1] = g_buffer[22];
	auxiliar[2] = g_buffer[23];
	auxiliar[3] = g_buffer[24];
	auxiliar[4] = '\0';
	g_DatosReferencia.nPosY = atoi(auxiliar);
    //Orientacion
    auxiliar[0] = g_buffer[25];
	auxiliar[1] = g_buffer[26];
	auxiliar[2] = g_buffer[27];
	auxiliar[3] = g_buffer[28];
	auxiliar[4] = '\0';
	if (g_DatosReferencia.nTipoRef == 3)
	  g_DatosReferencia.flOrientacion = atof(auxiliar);
	else
	  g_DatosReferencia.flOrientacion = atoi(auxiliar);
    g_DatosReferencia.nTipoControl = g_buffer[29]; //datos[29] = Tipo de Control: 0 --> Punto descentralizado; 1 --> Persecucin pura
	/*Si es punto descentralizado:
		datos[30-33] = Punto E
		datos[34-37] = ganancia Kpx
		datos[38-41] = ganancia Kpy
		datos[42-45] = ganancia Kvx
		datos[46-49] = ganancia Kvy*/
   	if (g_DatosReferencia.nTipoControl == 0)
   	{
        //Punto E
        auxiliar[0] = g_buffer[30];
        auxiliar[1] = g_buffer[31];
        auxiliar[2] = g_buffer[32];
        auxiliar[3] = g_buffer[33];
        auxiliar[4] = '\0';
        g_DatosReferencia.nPuntoE = atoi(auxiliar);
        //KPX
        auxiliar[0] = g_buffer[34];
        auxiliar[1] = g_buffer[35];
        auxiliar[2] = g_buffer[36];
        auxiliar[3] = g_buffer[37];
        auxiliar[4] = '\0';
        g_DatosReferencia.fKPX = atof(auxiliar);
        //KPY
        auxiliar[0] = g_buffer[38];
        auxiliar[1] = g_buffer[39];
        auxiliar[2] = g_buffer[40];
        auxiliar[3] = g_buffer[41];
        auxiliar[4] = '\0';
        g_DatosReferencia.fKPY = atof(auxiliar);
        //KVX
        auxiliar[0] = g_buffer[42];
        auxiliar[1] = g_buffer[43];
        auxiliar[2] = g_buffer[44];
        auxiliar[3] = g_buffer[45];
        auxiliar[4] = '\0';
        g_DatosReferencia.fKVX = atof(auxiliar);
        //KVY
        auxiliar[0] = g_buffer[46];
        auxiliar[1] = g_buffer[47];
        auxiliar[2] = g_buffer[48];
        auxiliar[3] = g_buffer[49];
        auxiliar[4] = '\0';
        g_DatosReferencia.fKVY = atof(auxiliar);
        g_DatosReferencia.k_rho=0;
        g_DatosReferencia.k_alpha=0;
        g_DatosReferencia.k_beta=0;
        g_DatosReferencia.kp=0;
	}
	else
	{
        //Si es persecucion pura
        auxiliar[0] = g_buffer[30];
        auxiliar[1] = g_buffer[31];
        auxiliar[2] = g_buffer[32];
        auxiliar[3] = g_buffer[33];
        auxiliar[4] = '\0';
        g_DatosReferencia.k_rho = atof(auxiliar);
        auxiliar[0] = g_buffer[34];
        auxiliar[1] = g_buffer[35];
        auxiliar[2] = g_buffer[36];
        auxiliar[3] = g_buffer[37];
        auxiliar[4] = '\0';
        g_DatosReferencia.k_alpha= atof(auxiliar);
        auxiliar[0] = g_buffer[38];
        auxiliar[1] = g_buffer[39];
        auxiliar[2] = g_buffer[40];
        auxiliar[3] = g_buffer[41];
        auxiliar[4] = '\0';
        g_DatosReferencia.k_beta= atof(auxiliar);
        auxiliar[0] = g_buffer[42];
        auxiliar[1] = g_buffer[43];
        auxiliar[2] = g_buffer[44];
        auxiliar[3] = g_buffer[45];
        auxiliar[4] = '\0';
        g_DatosReferencia.kp= atof(auxiliar);

        g_DatosReferencia.fKPX = 0;
        g_DatosReferencia.fKPY = 0;
        g_DatosReferencia.fKVX = 0;
        g_DatosReferencia.fKVY = 0;
	}
}

void RellenaPosiciones()
{
    unsigned char auxiliar[8];

    auxiliar[0] = g_buffer[0];
    auxiliar[1] = g_buffer[1];
    auxiliar[2] = g_buffer[2];
    auxiliar[3] = g_buffer[3];
    auxiliar[4] = g_buffer[4];
    auxiliar[5] = g_buffer[5];
    auxiliar[6] = g_buffer[6];
    auxiliar[7] = '\0';
    g_nPosInicialX = atoi(auxiliar);
    auxiliar[0] = g_buffer[7];
    auxiliar[1] = g_buffer[8];
    auxiliar[2] = g_buffer[9];
    auxiliar[3] = g_buffer[10];
    auxiliar[4] = g_buffer[11];
    auxiliar[5] = g_buffer[12];
    auxiliar[6] = g_buffer[13];
    auxiliar[7] = '\0';
    g_nPosInicialY = atoi(auxiliar);
    auxiliar[0] = g_buffer[14];
    auxiliar[1] = g_buffer[15];
    auxiliar[2] = g_buffer[16];
    auxiliar[3] = g_buffer[17];
    auxiliar[4] = g_buffer[18];
    auxiliar[5] = g_buffer[19];
    auxiliar[6] = g_buffer[20];
    auxiliar[7] = '\0';
    g_flOrientaInicial = atof(auxiliar);
    auxiliar[0] = g_buffer[21];
    auxiliar[1] = g_buffer[22];
    auxiliar[2] = g_buffer[23];
    auxiliar[3] = g_buffer[24];
    auxiliar[4] = g_buffer[25];
    auxiliar[5] = g_buffer[26];
    auxiliar[6] = g_buffer[27];
    auxiliar[7] = '\0';
    g_nPosFinalX = atoi(auxiliar);
    auxiliar[0] = g_buffer[28];
    auxiliar[1] = g_buffer[29];
    auxiliar[2] = g_buffer[30];
    auxiliar[3] = g_buffer[31];
    auxiliar[4] = g_buffer[32];
    auxiliar[5] = g_buffer[33];
    auxiliar[6] = g_buffer[34];
    auxiliar[7] = '\0';
    g_nPosFinalY = atoi(auxiliar);
    auxiliar[0] = g_buffer[35];
    auxiliar[1] = g_buffer[36];
    auxiliar[2] = g_buffer[37];
    auxiliar[3] = g_buffer[38];
    auxiliar[4] = g_buffer[39];
    auxiliar[5] = g_buffer[40];
    auxiliar[6] = g_buffer[41];
    auxiliar[7] = '\0';
    g_flOrientaFinal = atof(auxiliar);
}

void Procesa_Algoritmo(int conexion)
{
    int nResultado = 0, iResult = 0;
    unsigned char resultado[1];
    struct termios config;
    //Rellenamos los datos de referencia
    if (g_DatosReferencia.nTipoRef == 0) //rectangulo
        Generar_Rectangulo(g_DatosReferencia.nLado1,g_DatosReferencia.nLado2);
    if (g_DatosReferencia.nTipoRef == 1) //circunferencia
        Generar_Circulo(g_DatosReferencia.nRadio,g_DatosReferencia.fFrecuencia);
    if (g_DatosReferencia.nTipoRef == 2) //posicion inicial y final
        Generar_Trayectoria_Dos_Puntos(g_DatosReferencia.nPosFinalX,g_DatosReferencia.nPosFinalY);
    if (g_DatosReferencia.nTipoRef == 3) //trayectoria de la camara
        Generar_Trayectoria();
    //Antes de nada genero la trayectoria si es seguimiento por trayectoria
    //Control trayectoria
    if ((g_DatosReferencia.nTipoControl == 0) && (g_DatosReferencia.nTipoRef == 4) )
    {
        RellenaPosiciones();
        g_DatosReferencia.nPosX = g_nPosInicialX;
        g_DatosReferencia.nPosY = g_nPosInicialY;
        Generar_Trayectoria_Dos_Puntos(g_nPosFinalX,g_nPosFinalY);
    }
    //OJO hay que ver si no es perseucin pura preparar la trayectoria
    //Hacemos la recepcin asincrona. Me guardo antes la configuracion
    tcgetattr(conexion,&config);
    if (g_DatosReferencia.nTipoRef == 4)
    {
    if ( fcntl(conexion, F_SETFL, O_NONBLOCK) < 0 )
        perror("fcntl: no se puede fijar operaciones no bloqueantes");
    }
    //Conectamos el robot
    if (ConectaPuerto() == 1)
    {
        ModoComando(seguro);
        usleep (30000) ;
        //Ejecuta el algoritmo correspondiente
        if (g_DatosReferencia.nTipoControl == 0) //Control trayectoria
            nResultado = Control_Trayectoria(conexion);
        else
            nResultado = Control_Camino(conexion);
    }
    resultado[0] = nResultado;

    //Hacemos la recepcin sincrona.
    if (g_DatosReferencia.nTipoRef == 4)
    {
        if ( fcntl(conexion, F_SETFL, config) < 0 )
            perror("fcntl: no se puede fijar operaciones bloqueantes");
    }
    //Si hay algun error mandamos un 1, sino un 0 para que coja el fichero y lo abra con matlab
    iResult = send(conexion, resultado, 1, 0 );
    if (iResult != 1) {
        perror("Envio al cliente");
        close(conexion);
        DesconectaPuerto();
    }
    printf("Algoritmo finalizado. Envo de datos OK\n");
    //cerramos este socket
    close(conexion);
    //cerramos el puerto serie del robot
    DesconectaPuerto();
}

void Procesa_Algoritmo_Pelota(int conexion)
{
    int nResultado = 0, iResult = 0;
    unsigned char resultado[1];
    g_DatosReferencia.nPosX = g_nPosInicialX;
    g_DatosReferencia.nPosY = g_nPosInicialY;
    Generar_Trayectoria_Dos_Puntos(g_nPosFinalX,g_nPosFinalY);
    //Generar_Trayectoria_tres_PuntosIrPelota(g_nPosInicialX,g_nPosInicialY,g_nPosFinalX,g_nPosFinalY);
    //Conectamos el robot
    if (ConectaPuerto() == 1)
    {
        ModoComando(seguro);
        usleep (30000) ;
        //Ejecuta el algoritmo correspondiente
        if (g_DatosReferencia.nTipoControl == 0) //Control trayectoria
            nResultado = Control_Trayectoria(conexion);
        else
            nResultado = Control_Camino(conexion);
    }
    //Aqui ha llegado a su destino que es la pelota
    resultado[0] = 60;
    iResult = send(conexion, resultado, 1, 0 );
    if (iResult != 1) {
        perror("Envio al cliente");
        close(conexion);
        DesconectaPuerto();
    }
    printf("He llegado a la pelota. Espero a que me den orden para moverla\n");
    iResult = recv(conexion, resultado, 1, 0 );
    if (iResult != 1) {
        perror("Recepcin desde el cliente");
        close(conexion);
        DesconectaPuerto();
    }
    printf("Moviendo la pelota.\n");
    //Genero la trayectoria para ir desde el punto actual al punto final, que es aadirle 300 mm a la X
    g_DatosReferencia.nPosX = g_nPosFinalX;
    g_DatosReferencia.nPosY = g_nPosFinalY;
    g_flOrientaInicial = 0;
    Generar_Trayectoria_Dos_Puntos(g_nPosFinalX+200,g_nPosFinalY);
    //Vuelvo a llamar al algoritmo
    //Ejecuta el algoritmo correspondiente
    if (g_DatosReferencia.nTipoControl == 0) //Control trayectoria
        nResultado = Control_Trayectoria(conexion);
    else
        nResultado = Control_Camino(conexion);
    resultado[0] = 1;
    iResult = send(conexion, resultado, 1, 0 );
    if (iResult != 1) {
        perror("Envio al cliente");
        close(conexion);
        DesconectaPuerto();
    }
    printf("He empujado a la pelota. Moviendome a la posicon inicial\n");
    //Genero la trayectoria para ir desde el punto actual al inicio de donde empezo el robot
    g_DatosReferencia.nPosX = g_nPosFinalX+200;
    g_DatosReferencia.nPosY = g_nPosFinalY;
    Generar_Trayectoria_Dos_Puntos(g_nPosInicialX,g_nPosInicialY);
    //Generar_Trayectoria_tres_PuntosVolver(g_nPosFinalX+300,g_nPosFinalY,g_nPosInicialX,g_nPosInicialY);
    //Ejecuta el algoritmo correspondiente
    if (g_DatosReferencia.nTipoControl == 0) //Control trayectoria
        nResultado = Control_Trayectoria(conexion);
    else
        nResultado = Control_Camino(conexion);
    resultado[0] = 1;
    printf("He terminado\n");
    iResult = send(conexion, resultado, 1, 0 );
    printf("He enviado\n");
    if (iResult != 1) {
        perror("Envio al cliente");
        printf("Algun tipo de error\n");
        close(conexion);
        DesconectaPuerto();
    }
    printf("Algoritmos finalizado correctamente\n");
    //cerramos este socket
    close(conexion);
    //cerramos el puerto serie del robot
    DesconectaPuerto();
}

int Control_Camino(int conexion)
{
    int nDiferencia=0;
    struct timeval tvInicio, tvFin;
    struct timezone tz;
	short int nPosicion = 0, nAngulo = 0;
    int nTiempo = 0;
    int nVel_Izq = 0, nVel_Der = 0;
	FILE *fichero;
	int iResult=0;
	g_nParada = 0;
    //TODO EL ALGORITMO FUNCIONA EN METROS
	float b=(float)((float)B/1000.0); //mm (separacin entre las ruedas)/2
	//Posicion final que queremos alcanzar
	float goalPosx=(float)((float)g_nPosFinalX/1000.0);
	float goalPosy=(float)((float)g_nPosFinalY/1000.0);
	float goalPostheta=(float)(g_flOrientaFinal);
	float v_c=0.0;
	float omega_c=0.0;
	float rho_c=0;
	float beta_c=0;
	float alpha_c=0;
	//Posicion Inicial
    float theta=(float)(g_flOrientaInicial);      //orientacion del robot movil
    float x=(float)((float)g_nPosInicialX/1000.0);         //posicion X robot movil
    float y=(float)((float)g_nPosInicialY/1000.0);         //posicion Y robot movil
    float vref_d, vref_i;
	float flPosicion;
    int i=0;
    int nitetotal=1000;
	vref_d=0;
	vref_i=0;
    //Inicializo los encoders
    if (Distancia(&nPosicion) == 0)
        return 1;
    if (Angulo(&nAngulo) == 0)
        return 1;
    //Esto solo vale cuando no es una trayectoria. Sino es el principio de la trayectoria
    if (g_DatosReferencia.nTipoRef != 4)
    {
        if (g_DatosReferencia.nTipoRef != 3)
        {
            x = g_DatosReferencia.nPosX;
            y = g_DatosReferencia.nPosY;
            nAngulo = (int)g_DatosReferencia.flOrientacion;
            theta = (nAngulo * M_PI) /180;
         }
        else
        {
            x=0;
            y=0;
            theta = 0;
        }
    }
	fichero = fopen("datos.txt","w+");
    while(i < nitetotal)
    {
        //Empieza el tiempo
        gettimeofday( &tvInicio, &tz );
        //Calculamos donde deberia estar el robot
		if (Distancia(&nPosicion) == 0)
            return 1;
        flPosicion = (float)((float)(nPosicion)/1000);
        x = x + (flPosicion * cos(theta) );
        y = y + (flPosicion * sin(theta) );
        theta = theta + ( (float)((float)(vref_d-vref_i) / (float)(2*b)) * g_DatosReferencia.fTS);
        printf("PosX=%f PosY=%f Angulo=%f\n",x,y,theta);
		fprintf(fichero,"%f\t%f\n",x,y);

        rho_c = sqrt((x-goalPosx)*(x-goalPosx)+ (y-goalPosy)*(y-goalPosy));
        beta_c = -atan((goalPosy-y)/(goalPosx-x)) + goalPostheta;
        alpha_c = -beta_c-theta + goalPostheta;
        if (alpha_c>M_PI)
          alpha_c = (float)(alpha_c-2*M_PI);
        if (alpha_c<-M_PI)
          alpha_c = (float)(alpha_c+2*M_PI);
        v_c = g_DatosReferencia.k_rho*rho_c;
        omega_c = g_DatosReferencia.k_alpha*alpha_c+g_DatosReferencia.k_beta*beta_c;
        vref_i = v_c - (b/2)*omega_c;
        vref_d = v_c + (b/2)*omega_c;
        vref_i = vref_i*g_DatosReferencia.kp;
        vref_d = vref_d*g_DatosReferencia.kp;
        //Mandamos las velocidades. Pasamos a milimetros
        nVel_Izq = (int)(floor(vref_i*1000));
        nVel_Der = (int)(floor(vref_d*1000));
        //Limitamos las velocidades
        if (nVel_Izq > VEL_SUPERIOR)
          nVel_Izq = VEL_SUPERIOR;
        if (nVel_Izq < VEL_INFERIOR)
          nVel_Izq = VEL_INFERIOR;
        if (nVel_Der > VEL_SUPERIOR)
          nVel_Der = VEL_SUPERIOR;
        if (nVel_Der < VEL_INFERIOR)
          nVel_Der = VEL_INFERIOR;

		if (Velocidad_Independiente(nVel_Izq,nVel_Der) == 0)
            return 1;
        //Si se ha activado la parada paramos el robot
        if (g_nParada == 1)
        {
            printf("He salido con codigo 1\n");
            g_nParada = 0;
            fclose(fichero);
            if (Velocidad_Independiente(0,0) == 0)
                return 1;
            return 2;
        }
        //Si se ha reactivado la llamada. paramos este hilo y lanzamos otro hilo nuevo
        if (g_nParada == 3)
        {
            printf("He salido con codigo 3\n");
            g_nParada = 0;
            fclose(fichero);
            if (Velocidad_Independiente(0,0) == 0)
                return 1;
            return 3;
        }
        //Intentamos obtener nuevos datos
        //Recibimos los primeros datos de inicio y fin calculados de la camara, que son 43 bytes
        iResult = recv(conexion, g_buffer,43,0);
        if (iResult == 43)
        {
            RellenaPosiciones();
            //Actualizamos los valores
            goalPosx=(float)((float)g_nPosFinalX/1000.0);
            goalPosy=(float)((float)g_nPosFinalY/1000.0);
            goalPostheta=(float)(g_flOrientaFinal);
            theta=(float)(g_flOrientaInicial);      //orientacion del robot movil
            x=(float)((float)g_nPosInicialX/1000.0);         //posicion X robot movil
            y=(float)((float)g_nPosInicialY/1000.0);         //posicion Y robot movil
            vref_d=0;
            vref_i=0;

            i=0;
        }
        //Aqui termina el tiempo. Esto es para restarlo al periodo a ver si funciona mejor
        gettimeofday( &tvFin, &tz );
        nDiferencia = (int)(tvFin.tv_sec*1000000 + tvFin.tv_usec) - (int)(tvInicio.tv_sec*1000000 + tvInicio.tv_usec);
        //Esperamos para la siguiente muestra
        nTiempo = (int)((g_DatosReferencia.fTS*1000000) - nDiferencia);
        if (nTiempo > 0)
            usleep(nTiempo);
        i++;
    }
	fclose(fichero);
	//Paramos el robot
	if (Velocidad_Independiente(0,0) == 0)
        return 1;
    return 0;
}
