#include <stdio.h>
#include <stdlib.h>
#include "Control_Robot.h"
#include <time.h>

/**La comunicacin de sockets consta bsicamente de dos partes. Por un lado, lo primero que recibimos es el comando
que tenemos que hacer. Esta estructura ira
creciendo en funcin de las nuevas necesidades. Por regla general cuando enviamos un 0 por sockets significa que todo
ha ido bien sino se envia un 1 y es que ha habido algun problema. Bsicamente existen los siguientes cdigos:
10 --> Seguimiento de la trayectoria
20 --> Parada de emergencia
30 --> parada del algoritmo actual y reanudacin con nuevos datos del algoritmo de control
50 --> Trabajo coordinado con el Koala*/

int main()
{
    int conexion = 0, iResult = 0, nResultado = 0, res = 0, nCont = 0, nLongitud, nTamTotal;
    unsigned char resultado[1], codigo[1], chAux[5];
    //referencias que recibo cuando es una trayectoria
    unsigned char *g_Referencias;
    g_nParada = 0; //parada de emergencia desactivada
    iResult  = ConexionServidor();
    if (iResult != -1)
    {
        while (1)
        {
            conexion = NuevaPeticion();
            if (conexion != -1)
            {
                //Recibimos los datos
                iResult = recv(conexion, codigo,1,0);
                if (iResult != 1)
                {
                    perror("Problema en recepcin del cdigo a ejecutar");
                    close(conexion);
                }
                printf("Recepcin OK. Cdigo = %d\n",codigo[0]);
                resultado[0] = 0;
                iResult = send( conexion, resultado, 1, 0 );
                if (iResult != 1) {
                    perror("Envio al cliente errneo");
                    close(conexion);
                }
                printf("Cdigo aceptado. Procesando datos...\n");
                //Si ha llegado un 100 es para procesar el algoritmo
                if (codigo[0] == 10)
                {
                    iResult = recv(conexion, g_buffer,51,0);
                    if (iResult == -1)
                    {
                        perror("Recepcion");
                        close(conexion);
                    }
                    if (iResult != 51)
                    {
                        perror("No se han recibido los 51 bytes");
                        close(conexion);
                    }
                    if (iResult == 51)
                    {
                        //Rellena la estructura de datos
                        RellenaEstructura();
                        if (g_DatosReferencia.nTipoRef == 4)
                        {
                            //Recibimos los primeros datos de inicio y fin calculados de la camara, que son 43 bytes
                            iResult = recv(conexion, g_buffer,43,0);
                            if (iResult != 43)
                            {
                                perror("No se han recibido los 43 bytes de posiciones");
                                close(conexion);
                            }
                            else {
                                RellenaPosiciones();
                                g_DatosReferencia.nPosX = g_nPosInicialX;
                                g_DatosReferencia.nPosY = g_nPosInicialY;
                                printf("XRecibido=%d YRecibido=%d\n",g_nPosInicialX,g_nPosInicialY);
                            }
                        }
                        printf("RECEPCIN DE ESTRUCTURA DE DATOS OK. PROCESANDO ALGORITMO...\n");
                        pthread_t algoritmo;
                        res = pthread_create(&algoritmo,NULL,(void *)&Procesa_Algoritmo,(void *)conexion);
                        if (res)
                            perror("No se ha podido crear el hilo de ejecucin. ERROR: " + res);
                    }
                }
                //Si ha llegado un 200 es una parada de emergencia
                if (codigo[0] == 20)
                {
                    g_nParada = 1; //parada de emergencia activada
                    close(conexion);
                }
                if (codigo[0] == 30)
                {
                    //Procesamos el algoritmo pero antes debe morir el hilo si ya estaba en ejecucion
                    g_nParada = 3; //recativacion del algoritmo
                    //Le dejamos tiempo para que acabe el algoritmo
                    usleep(1000000);

                    iResult = recv(conexion, g_buffer,51,0);
                    if (iResult == -1)
                    {
                        perror("Recepcion");
                        close(conexion);
                    }
                    if (iResult != 51)
                    {
                        perror("No se han recibido los 51 bytes");
                        close(conexion);
                    }
                    if (iResult == 51)
                    {
                        resultado[0] = 0;
                        iResult = send( conexion, resultado, 1, 0 );
                        if (iResult != 1) {
                            perror("Envio al cliente errneo");
                            close(conexion);
                        }
                        printf("estructura de datos OK. esperando referencias...\n");
                        //Rellena la estructura de datos
                        RellenaEstructura();

                        //Ahora lo que esperamos son las referencias
                        nTamTotal = (4*(g_DatosReferencia.nTamReferencias+g_DatosReferencia.nTamReferencias))+1;
                        g_Referencias  = (unsigned char *)malloc( nTamTotal * sizeof(unsigned char));
                        g_nRefX = (int *)malloc(g_DatosReferencia.nTamReferencias * sizeof(int));
                        g_nRefY = (int *)malloc(g_DatosReferencia.nTamReferencias * sizeof(int));

                        iResult = recv(conexion, g_Referencias,nTamTotal,0);
                        if (iResult == -1)
                        {
                            perror("No se ha podido recibir los datos de referencia");
                            close(conexion);
                        }
                        if (iResult != nTamTotal )
                        {
                            perror("No se han recibido todos los bytes de las referencias" );
                            close(conexion);
                        }
                        if (iResult == nTamTotal )
                        {
                            //COMPONENTES X
                            for (nCont = 0;nCont < g_DatosReferencia.nTamReferencias; nCont++)
                            {
                                nLongitud = nCont*4;
                                chAux[0] = g_Referencias[nLongitud];
                                chAux[1] = g_Referencias[nLongitud+1];
                                chAux[2] = g_Referencias[nLongitud+2];
                                chAux[3] = g_Referencias[nLongitud+3];
                                chAux[4] = '\0';
                                g_nRefX[nCont] = atoi(chAux);
                            }
                            //COMPONENTE Y
                            for (nCont = 0;nCont < g_DatosReferencia.nTamReferencias; nCont++)
                            {
                                nLongitud = (4 * g_DatosReferencia.nTamReferencias) + (nCont*4);
                                chAux[0] = g_Referencias[nLongitud];
                                chAux[1] = g_Referencias[nLongitud+1];
                                chAux[2] = g_Referencias[nLongitud+2];
                                chAux[3] = g_Referencias[nLongitud+3];
                                chAux[4] = '\0';
                                g_nRefY[nCont] = atoi(chAux);
                            }
                            //Ya podemos liberar el vector temporal
                            free(g_Referencias);
                            printf("RECEPCIN DE ESTRUCTURA DE DATOS OK. PROCESANDO ALGORITMO...\n");
                            pthread_t algoritmo;
                            res = pthread_create(&algoritmo,NULL,(void *)&Procesa_Algoritmo,(void *)conexion);
                            if (res)
                                perror("No se ha podido crear el hilo de ejecucin. ERROR: " + res);
                        }
                    }
                }

                if (codigo[0] == 50)
                {
                    iResult = recv(conexion, g_buffer,51,0);
                    if (iResult == -1)
                    {
                        perror("Recepcion");
                        close(conexion);
                    }
                    if (iResult != 51)
                    {
                        perror("No se han recibido los 51 bytes");
                        close(conexion);
                    }
                    if (iResult == 51)
                    {
                        //Rellena la estructura de datos
                        RellenaEstructura();
                        //Recibimos los primeros datos de inicio y fin calculados de la camara, que son 43 bytes
                        iResult = recv(conexion, g_buffer,43,0);
                        if (iResult != 43)
                        {
                            perror("No se han recibido los 43 bytes de posiciones");
                            close(conexion);
                        }
                        else
                        {
                            RellenaPosiciones();
                            //Lanzamos un hilo para ejecutar el programa
                            printf("RECEPCIN DE POSICIONES OK. PROCESANDO ALGORITMO DE SEGUIMIENTO...\n");
                            pthread_t algoritmo;
                            res = pthread_create(&algoritmo,NULL,(void *)&Procesa_Algoritmo_Pelota,(void *)conexion);
                            if (res)
                                perror("No se ha podido crear el hilo de ejecucin. ERROR: " + res);
                        }
                    }
                }

             }
        }
    }
    close(g_sockfd);
    return 0;
}

