function [salx,saly,nError,OrientacionXY]=detecta(tvisu,RASTER)
%RASTER=10; %Es lo que mide el robot en pixeles alrededor de 70 pixeles
%Matriz de configuracin obtenida de la calibracin de la camara
nError=0;
OrientacionXY=0;
salx=0;
saly=0;

theta =[-5.557190660439 0.142628475911 0
         0.115215296172 5.533663392034 0
      1521.5431137392655 -190.250769088174 1];

ImagenCamara = imread('temp.bmp');
if tvisu == 1
    figure(1);
    title('Imagen original');
    imshow(ImagenCamara);
end;
%%%%%%%%%%%%%%%%%%PARTE 1. DETECCION DE LA POSICION INICIAL%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%Y ORIENTACION DEL ROBOT%%%%%%%%%%%%%%%%%%%%%%%%
%Segmentamos la imagen  para que solo coja el carton triangular negro que
%es la posicion inciail del robot. 
ImagenSegmentada=((ImagenCamara(:,:,1)<70)&(ImagenCamara(:,:,2)<70)&(ImagenCamara(:,:,3)<70));
%Erosion y dilatacin para suavizar el resultado
se3 = strel('square',2);
imaero=imerode(ImagenSegmentada,se3);
imaero=imerode(imaero,se3);
imadila=imdilate(imaero,se3);
imadila=imdilate(imadila,se3);

if tvisu == 1
    figure(2);
    title('posicion inicial');
    imshow(imadila);
end;

[Ieti,nobjetos]=bwlabel(imadila);
if nobjetos == 1
    s  = regionprops(Ieti, 'centroid');
    PosInicialPIXEL=s.Centroid;
else
    %Error ya que solo puede haber un objeto. devolvemos -10
    nError = -10;
    OrientacionXY=0;
    salx=0;
    saly=0;
    return;
end
% vamos a obtener el perimetro a partir de bwr, aunque es igual si se hace a
% partir de bw
imaperim=bwperim(imadila);
coordenadas=coordperime(imaperim);  
% calculamos la distancia entre los puntos de la frontera y el centro de
% gravedad del objeto
puntomaslejano=distcdm(PosInicialPIXEL,coordenadas);
PosInicialXY=theta'*[PosInicialPIXEL';1];
plejanoxy=theta'*[puntomaslejano';1];
%Calculamos la orientacion incial del robot
OrientacionXY=atan2((plejanoxy(2)-PosInicialXY(2) ),(plejanoxy(1)-PosInicialXY(1)));
%Para el algoritmo utilizamos el centro en pixeles

%%%%%%%%%%%%%%%%%%PARTE 2. DETECCION DE LA POSICION FINAL%%%%%%%%%%%%%%%%
ImagenSegmentada=((ImagenCamara(:,:,1)<256)&(ImagenCamara(:,:,2)<130)&(ImagenCamara(:,:,3)<130) &...
                  (ImagenCamara(:,:,1)>150)&(ImagenCamara(:,:,2)>40)&(ImagenCamara(:,:,3)>40));
%Erosion y dilatacin para suavizar el resultado
se3 = strel('square',1);
imaero=imerode(ImagenSegmentada,se3);
imaero=imerode(imaero,se3);
imadila=imdilate(imaero,se3);
imadila=imdilate(imadila,se3);
if tvisu == 1
    figure(3);
    title('posicion final');
    imshow(imadila);
end;

[Ieti,nobjetos]=bwlabel(imadila);
if nobjetos == 1
    s  = regionprops(Ieti, 'centroid');
    PosFinalPIXEL=s.Centroid;
else
    %Error ya que solo puede haber un objeto final. devolvemos -20
    nError = -20;
    OrientacionXY=0;
    salx=0;
    saly=0;    
    return;
end

% vamos a obtener el perimetro a partir de bwr, aunque es igual si se hace a
% partir de bw
imaperim=bwperim(imadila);
coordenadas=coordperime(imaperim);  
% calculamos la distancia entre los puntos de la frontera y el centro de
% gravedad del objeto
PosFinalXY=theta'*[PosFinalPIXEL';1];

%%%%%%%%%%%%%%%%%%PARTE 3. DETECCION DE OBSTACULOS%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% ALGORITMO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x_start =  [ PosInicialPIXEL(1) , PosInicialPIXEL(2) ];
x_target = [ PosFinalPIXEL(1)   , PosFinalPIXEL(2)   ];
%Detecta obstaculos que son de color azul
ImagenSegmentada=((ImagenCamara(:,:,1)<120)&(ImagenCamara(:,:,2)<200)&(ImagenCamara(:,:,3)<257) &...
                  (ImagenCamara(:,:,1)>40)&(ImagenCamara(:,:,2)>90)&(ImagenCamara(:,:,3)>150));

%Dilatamos mucho los obstaculos para aadir el radio del robot
se3 = strel('square',2);
imaero=imerode(ImagenSegmentada,se3);
imaero=imerode(imaero,se3);
imadila=imdilate(imaero,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);
imadila=imdilate(imadila,se3);

if tvisu == 1
    figure(4);
    title('obstaculos');
    imshow(imadila);
end;

[ array , x_vec , y_vec] = getReducedArray( x_start(1) , x_start(1) , imadila , RASTER );
[x y ] = getCellIndices( x_start , x_vec , y_vec );
startCell = [x,y];
[x y ] = getCellIndices( x_target , x_vec , y_vec );
targetCell = [x,y];
[ nodes ] = findPath( array , startCell, targetCell );
points = getCoordinatesFromNodes( x_vec(1), y_vec(1) , RASTER ,RASTER , nodes );
points(1,:) = x_start;
points(end,:) = x_target;
realPoints = [];


for i = 1:length( points(:,1) )
    buffer = theta*[points(i,1),points(i,2),1]';
    realPoints(i,:) = buffer(1:2);
end

picSpline = cscvn( points' ); %-> natural spline
spline = cscvn( realPoints' ); %-> natural spline

if tvisu==1
    plotPicWithGrid( imadila , array , x_vec , y_vec , x_start, x_target , points ,spline);
    plotPicWithGrid( imadila , array , x_vec , y_vec , x_start, x_target , points ,picSpline);
end

%Devolvemos el camino en pixeles
aux=theta'*[points';ones(1,size(points,1))];
salx=aux(1,:);
saly=aux(2,:);
salx=salx';
saly=saly';