function [ nodes ] = findPath( array , startCell, targetCell )
global ListToCheck;
global distArray;

s = size( array );

w = s(2); % width of the array ( columns)
h = s(1); % height of the array ( rows )

xakt = startCell(1);
yakt = startCell(2);
cl = 0;

ListToCheck = [];
distArray = array;
distArray( yakt, xakt ) = 1;

checkNeighbours( xakt , yakt , cl , w , h );

while ( length(ListToCheck) > 0 )
    xakt = ListToCheck(1,1);
    yakt = ListToCheck(1,2); 
    cl = ListToCheck(1,3);
    
    if ( length(ListToCheck) == 1)
        ListToCheck = []; 
    else
        ListToCheck = ListToCheck(2:end,:);
    end

    checkNeighbours( xakt , yakt , cl , w , h );
end

for i = 1:w 
    for j = 1:h
        if ( distArray(j,i) == 0 )
            distArray(j,i) = -2;
        end
    end
end
distArray( startCell(2) , startCell(1) ) = 0;

if ( distArray(targetCell(2) , targetCell(1)) > 0 )
    nodes = reversSearch( distArray , targetCell(1) , targetCell(2) , w , h );
else
    nodes = [];
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rs = reversSearch( distArray , xTarget , yTarget, w , h )
cDist = distArray( yTarget , xTarget);
rs = [getFieldID(xTarget , yTarget, w) ,xTarget , yTarget, cDist];

lastX = xTarget;
lastY = yTarget;

while ( cDist > 0 )
    cx = lastX -1;
    cy = lastY;
    
    if ( isWithinArray( cx , cy , w , h ) )
        if ( distArray( cy, cx ) == cDist -1 )
            rs = [getFieldID( cx , cy , w), cx , cy, cDist - 1 ; rs ];
            lastX = cx;
            lastY = cy;
            cDist = cDist - 1;
            continue;
        end
    end
    
    cx = lastX + 1;
    cy = lastY;
    
    if ( isWithinArray( cx , cy , w , h ) )
        if ( distArray( cy, cx ) == cDist -1 )
            rs = [getFieldID( cx , cy , w), cx , cy, cDist - 1 ; rs ];
            lastX = cx;
            lastY = cy;
            cDist = cDist - 1;
            continue;
        end
    end

    cx = lastX ;
    cy = lastY -1;
    
    if ( isWithinArray( cx , cy , w , h ) )
        if ( distArray( cy, cx ) == cDist -1 )
            rs = [getFieldID( cx , cy , w), cx , cy, cDist - 1 ; rs ];
            lastX = cx;
            lastY = cy;
            cDist = cDist - 1;
            continue;
        end
    end

    cx = lastX ;
    cy = lastY +1;
    
    if ( isWithinArray( cx , cy , w , h ) )
        if ( distArray( cy, cx ) == cDist -1 )
            rs = [getFieldID( cx , cy , w), cx , cy, cDist - 1 ; rs ];
            lastX = cx;
            lastY = cy;
            cDist = cDist - 1;
            continue;
        end
    end
end

function iwa = isWithinArray( x , y , w , h)

if ( (x > 0) & (x <= w) & ( y > 0) & ( y <= h) )
    iwa = 1;
else
    iwa = 0;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function checkNeighbours( x , y , currentLength , width, height )
global ListToCheck;
    cl = currentLength + 1;

    if  ( x > 1 ) 
        addToList( x-1, y , cl);

%         if ( y > 1)
%             addToList( x-1, y-1 , cl);
%         end
%         if ( y < height )
%             addToList( x-1, y+1 , cl);
%         end
    end
    if  ( x < width )
        addToList( x+1, y , cl);

%         if ( y > 1)
%             addToList( x+1, y-1 , cl);
%         end
%         if ( y < height )
%             addToList( x+1, y+1 , cl);
%         end
    end

    if ( y > 1)
        addToList( x, y-1 , cl);
    end
    if ( y < height ) 
        addToList( x, y+1 , cl);
    end
    
    %disp( '----------------------------' )
    %disp( ListToCheck )
    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% add to waiting list
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function add = addToList( x, y , currentLength)
global ListToCheck;
global distArray;

    if ( distArray( y , x ) == 0 )
        distArray( y , x ) = currentLength;
        ListToCheck = [ListToCheck; x y currentLength];
    end
        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% calculate the row and colums indeces (Matlab) from ID
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [x , y] = getFieldIndex( ID , width )
    y = mod( ID , width) + 1;
    x = uint16( ( ID - mod(ID,width)) / width ) + 1;
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% calculate the field index from x and y
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ID = getFieldID( x , y , width )
    ID = (x-1) * width + (y-1);