function [result, x_vec , y_vec] = getReducedArray( x_start, y_start, boolArray, rec_length )

s = size( boolArray );

w = s(2);
h = s(1);

level = (0.01*rec_length*rec_length);

rec_length_x = rec_length;
rec_length_y = rec_length;

o_x = mod( x_start - rec_length_x/2 , rec_length_x );
o_y = mod( y_start - rec_length_y/2 , rec_length_y );

num_x = ((w - o_x) - mod( (w - o_x), rec_length_x ) )/ rec_length_x;
num_y = ((h - o_y) - mod( (h - o_y), rec_length_y ) )/ rec_length_y;

result = zeros( num_y , num_x );
if ( o_x == 0)
    x_vec = [1];
else
    x_vec = [o_x];
end
if ( o_y == 0)
    y_vec = [1];
else
    y_vec = [o_y];
end

for i = 1 : num_y
    y = o_y + (i-1)*rec_length_y ;

    for j = 1 : num_x
        x = o_x + (j-1)*rec_length_x ;
        
        if ( i == 1)
            x_vec = [ x_vec ; x + + rec_length_x ];
        end
        result( i , j ) = isRectObstacle( boolArray , x , y , x + rec_length_x , y + rec_length_y , level);  
    end
    y_vec = [ y_vec ; y + rec_length_y ];
end



function ir = isRectObstacle( boolArray , x1 , y1 , x2 ,y2 , level )
x1 = max(x1,1);
y1 = max(y1,1);
if ( sum(sum( boolArray(y1:y2,x1:x2))) > level )
    ir = -1;
else
    ir = 0;
end