function plotPicWithGrid( boolArray , redBoolArray , x_vec , y_vec , startCell, targetCell , nodes , spline)
s = size( boolArray );
s2 = size( redBoolArray );

w = s(2);
h = s(1);
w2 = s2(2);
h2 = s2(1);

dx = x_vec(end) - x_vec(end-1);
dy = y_vec(end) - y_vec(end-1);

x_start = startCell(1);
y_start = startCell(2);
x_end = targetCell(1);
y_end = targetCell(2);

figure
imshow( boolArray )
hold on

for i = 1:length(x_vec)
    h = line( [x_vec(i) x_vec(i)],[0 h] );
    set( h , 'Color', 'b')
end
for i = 1:length(y_vec)
    h = line( [0 w],[y_vec(i) y_vec(i)] );
    set( h , 'Color', 'b')
end

for i = 1:w2
    for j = 1:h2
        if ( redBoolArray( j, i) == -1 )
            x = x_vec(1) + (i-1)*dx ;
            y = y_vec(1) + (j-1)*dy ;
            h = line( [x x+dx],[y y+dy] );
            set( h , 'Color', 'r')            
            h = line( [x+dx x],[y y+dy] );
            set( h , 'Color', 'r')            
        end
    end
end

if ( nargin > 5)
    h = rectangle('Position', [x_start-2 y_start-2 4 4] );
    set( h , 'EdgeColor', 'g')
    h = rectangle('Position', [x_end-2 y_end-2 4 4] );
    set( h , 'EdgeColor', 'y')
end

if ( nargin > 6)
    for i = 1 : length(nodes)
        h = rectangle('Position', [nodes(i,1)-2 nodes(i,2)-2 4 4] ,'Curvature',[1,1]);
        set( h , 'EdgeColor', 'r')
    end
end

if ( nargin > 7)
%    figure
    fnplt(spline,'r')
end
hold off

